/* A packrat parser generated by PackCC 1.2.2 */

#ifdef _MSC_VER
#undef _CRT_SECURE_NO_WARNINGS
#define _CRT_SECURE_NO_WARNINGS
#endif /* _MSC_VER */
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#ifndef _MSC_VER
#if defined __GNUC__ && defined _WIN32 /* MinGW */
static size_t strnlen(const char *str, size_t maxlen) {
    size_t i;
    for (i = 0; i < maxlen && str[i]; i++);
    return i;
}
#else
#include <unistd.h> /* for strnlen() */
#endif /* defined __GNUC__ && defined _WIN32 */ 
#endif /* !_MSC_VER */

#include "schema_type_parse.h"

#include "schema_type_parse.h"
#include "maestro/logging.h"
#include <inttypes.h>
#include <limits.h>
#include <float.h>
#include <assert.h>

#include <maestro/i_utlist.h>


/* simplify logging */
#define DEBUG(...) LOG_DEBUG(MSTRO_LOG_MODULE_ATTR,__VA_ARGS__)
#define INFO(...)  LOG_INFO(MSTRO_LOG_MODULE_ATTR,__VA_ARGS__)
#define WARN(...)  LOG_WARN(MSTRO_LOG_MODULE_ATTR,__VA_ARGS__)
#define ERR(...)   LOG_ERR(MSTRO_LOG_MODULE_ATTR,__VA_ARGS__)



struct mstro_stp_parser_ctx {
  const char * string;
  size_t next;
  bool got_error;
};

static inline int
mstro_stp__getchar(struct mstro_stp_parser_ctx *input) {
  if(!input)
    return -1;
  else if(input->string[input->next]=='\0')
    return -1;
  else
    return (int)input->string[input->next++];
}

#define PCC_GETCHAR(auxil) mstro_stp__getchar(auxil)

#define PCC_ERROR(auxil) do {                                 \
   ERR("Schema type parser error around string position %zu of |%s|\n", \
         auxil->next, auxil->string);                         \
   auxil->got_error=true;                                     \
   } while(0)


static inline
struct mstro_stp_val *
mstro_stp_val_alloc(enum mstro_stp_val_kind kind)
{
  struct mstro_stp_val *res = malloc(sizeof(struct mstro_stp_val));
  if(res!=NULL) {
    res->kind = kind;
    switch(kind) {
      /* set defaults */
      case MSTRO_STP_BOOL:
        break;
      case MSTRO_STP_UINT:
        res->uint_min = 0; res->uint_max = UINT64_MAX;
        break;
      case MSTRO_STP_INT:
        res->int_min = INT64_MIN; res->int_max = INT64_MAX;
        break;
      case MSTRO_STP_FLOAT:
        res->float_min = -FLT_MAX; res->float_max = FLT_MAX;
        break;
      case MSTRO_STP_DOUBLE:
        res->double_min = -DBL_MAX; res->double_max = DBL_MAX;
        break;
      case MSTRO_STP_STR:
        res->str_minlen = 0;
        res->str_maxlen = MSTRO_STP_VAL_SIZE_MAX;
        res->str_excludedchars = NULL;
        break;
      case MSTRO_STP_EXCLSTR:
        res->exclstrval=NULL;
        break;
      case MSTRO_STP_ICASE:
        res->icase = false;
        break;
      case MSTRO_STP_NAME:
        res->nameval = NULL;
        break;
      case MSTRO_STP_REGEX:
        res->regex_numpatterns = 0;
        res->regex_patterns = NULL;
        res->regex_name = NULL;
        res->regex_ignorecase = false;
        break;
      case MSTRO_STP_BLOB:
        res->blob_minlen = 0;
        res->blob_maxlen = MSTRO_STP_VAL_SIZE_MAX;
        break;
      case MSTRO_STP_ERROR:
        res->errmsg = NULL;
        break;
      case MSTRO_STP_STRVAL:
        res->strval = NULL;
        break;
      case MSTRO_STP_LIST:
        res->list_entry = NULL;
        res->list_tail = NULL;
        break;
      case MSTRO_STP_MININT:
        res->minintval=INT64_MIN;
        break;
      case MSTRO_STP_MINUINT:
        res->minuintval=0;
        break;
      case MSTRO_STP_MAXINT:
        res->maxintval=INT64_MAX;
        break;
      case MSTRO_STP_MAXUINT:
        res->maxuintval=UINT64_MAX;
        break;
      case MSTRO_STP_MINFLOAT:
        res->minfloatval=-FLT_MAX;
        break;
      case MSTRO_STP_MAXFLOAT:
        res->maxfloatval=FLT_MAX;
        break;
      case MSTRO_STP_MINDOUBLE:
        res->mindoubleval=-DBL_MAX;
        break;
      case MSTRO_STP_MAXDOUBLE:
        res->maxdoubleval=DBL_MAX;
        break;

      /* cases that do not have restrictions */
        case MSTRO_STP_INTVAL:
        case MSTRO_STP_UINTVAL:
        case MSTRO_STP_FLOATVAL:
        case MSTRO_STP_DOUBLEVAL:
        case MSTRO_STP_BOOLVAL:
        case MSTRO_STP_TIMESTAMP:
        case MSTRO_STP_POINTER:
        break;

        break;

      default:
        ERR("No default restrictions set for type %d\n", kind);
    }
  }
  return res;
}


static inline
struct mstro_stp_val *mstro_stp_val__cons(struct mstro_stp_val *car,struct mstro_stp_val *cdr)
{
  struct mstro_stp_val *cons = mstro_stp_val_alloc(MSTRO_STP_LIST);
  if(cons) {
    cons->list_entry = car;
    cons->list_tail  = cdr;
  }

  return cons;
}


void
mstro_stp_val__describe(const struct mstro_stp_val *v);

struct mstro_stp_val *
mstro_stp_val__build_restricted_type(
  struct mstro_stp_val *typename,
  struct mstro_stp_val *args);


#ifndef PCC_BUFFERSIZE
#define PCC_BUFFERSIZE 256
#endif /* !PCC_BUFFERSIZE */

#ifndef PCC_ARRAYSIZE
#define PCC_ARRAYSIZE 2
#endif /* !PCC_ARRAYSIZE */

typedef enum pcc_bool_tag {
    PCC_FALSE = 0,
    PCC_TRUE
} pcc_bool_t;

typedef struct pcc_char_array_tag {
    char *buf;
    int max;
    int len;
} pcc_char_array_t;

typedef struct pcc_range_tag {
    int start;
    int end;
} pcc_range_t;

typedef struct mstro_stp_val *pcc_value_t;

typedef struct mstro_stp_parser_ctx *pcc_auxil_t;

typedef struct pcc_value_table_tag {
    pcc_value_t *buf;
    int max;
    int len;
} pcc_value_table_t;

typedef struct pcc_value_refer_table_tag {
    pcc_value_t **buf;
    int max;
    int len;
} pcc_value_refer_table_t;

typedef struct pcc_capture_tag {
    pcc_range_t range;
    char *string; /* mutable */
} pcc_capture_t;

typedef struct pcc_capture_table_tag {
    pcc_capture_t *buf;
    int max;
    int len;
} pcc_capture_table_t;

typedef struct pcc_capture_const_table_tag {
    const pcc_capture_t **buf;
    int max;
    int len;
} pcc_capture_const_table_t;

typedef struct pcc_thunk_tag pcc_thunk_t;
typedef struct pcc_thunk_array_tag pcc_thunk_array_t;

typedef void (*pcc_action_t)(mstro_stp_context_t *, pcc_thunk_t *, pcc_value_t *);

typedef enum pcc_thunk_type_tag {
    PCC_THUNK_LEAF,
    PCC_THUNK_NODE,
} pcc_thunk_type_t;

typedef struct pcc_thunk_leaf_tag {
    pcc_value_refer_table_t values;
    pcc_capture_const_table_t capts;
    pcc_capture_t capt0;
    pcc_action_t action;
} pcc_thunk_leaf_t;

typedef struct pcc_thunk_node_tag {
    const pcc_thunk_array_t *thunks; /* just a reference */
    pcc_value_t *value; /* just a reference */
} pcc_thunk_node_t;

typedef union pcc_thunk_data_tag {
    pcc_thunk_leaf_t leaf;
    pcc_thunk_node_t node;
} pcc_thunk_data_t;

struct pcc_thunk_tag {
    pcc_thunk_type_t type;
    pcc_thunk_data_t data;
};

struct pcc_thunk_array_tag {
    pcc_thunk_t **buf;
    int max;
    int len;
};

typedef struct pcc_thunk_chunk_tag {
    pcc_value_table_t values;
    pcc_capture_table_t capts;
    pcc_thunk_array_t thunks;
    int pos;
} pcc_thunk_chunk_t;

typedef struct pcc_lr_entry_tag pcc_lr_entry_t;

typedef enum pcc_lr_answer_type_tag {
    PCC_LR_ANSWER_LR,
    PCC_LR_ANSWER_CHUNK,
} pcc_lr_answer_type_t;

typedef union pcc_lr_answer_data_tag {
    pcc_lr_entry_t *lr;
    pcc_thunk_chunk_t *chunk;
} pcc_lr_answer_data_t;

typedef struct pcc_lr_answer_tag pcc_lr_answer_t;

struct pcc_lr_answer_tag {
    pcc_lr_answer_type_t type;
    pcc_lr_answer_data_t data;
    int pos;
    pcc_lr_answer_t *hold;
};

typedef pcc_thunk_chunk_t *(*pcc_rule_t)(mstro_stp_context_t *);

typedef struct pcc_rule_set_tag {
    pcc_rule_t *buf;
    int max;
    int len;
} pcc_rule_set_t;

typedef struct pcc_lr_head_tag pcc_lr_head_t;

struct pcc_lr_head_tag {
    pcc_rule_t rule;
    pcc_rule_set_t invol;
    pcc_rule_set_t eval;
    pcc_lr_head_t *hold;
};

typedef struct pcc_lr_memo_tag {
    pcc_rule_t rule;
    pcc_lr_answer_t *answer;
} pcc_lr_memo_t;

typedef struct pcc_lr_memo_map_tag {
    pcc_lr_memo_t *buf;
    int max;
    int len;
} pcc_lr_memo_map_t;

typedef struct pcc_lr_table_entry_tag {
    pcc_lr_head_t *head; /* just a reference */
    pcc_lr_memo_map_t memos;
    pcc_lr_answer_t *hold_a;
    pcc_lr_head_t *hold_h;
} pcc_lr_table_entry_t;

typedef struct pcc_lr_table_tag {
    pcc_lr_table_entry_t **buf;
    int max;
    int len;
} pcc_lr_table_t;

struct pcc_lr_entry_tag {
    pcc_rule_t rule;
    pcc_thunk_chunk_t *seed; /* just a reference */
    pcc_lr_head_t *head; /* just a reference */
};

typedef struct pcc_lr_stack_tag {
    pcc_lr_entry_t **buf;
    int max;
    int len;
} pcc_lr_stack_t;

struct mstro_stp_context_tag {
    int pos;
    pcc_char_array_t buffer;
    pcc_lr_table_t lrtable;
    pcc_lr_stack_t lrstack;
    pcc_auxil_t auxil;
};

#ifndef PCC_ERROR
#define PCC_ERROR(auxil) pcc_error()
static void pcc_error(void) {
    fprintf(stderr, "Syntax error\n");
    exit(1);
}
#endif /* !PCC_ERROR */

#ifndef PCC_GETCHAR
#define PCC_GETCHAR(auxil) getchar()
#endif /* !PCC_GETCHAR */

#ifndef PCC_MALLOC
#define PCC_MALLOC(auxil, size) pcc_malloc_e(size)
static void *pcc_malloc_e(size_t size) {
    void *const p = malloc(size);
    if (p == NULL) {
        fprintf(stderr, "Out of memory\n");
        exit(1);
    }
    return p;
}
#endif /* !PCC_MALLOC */

#ifndef PCC_REALLOC
#define PCC_REALLOC(auxil, ptr, size) pcc_realloc_e(ptr, size)
static void *pcc_realloc_e(void *ptr, size_t size) {
    void *const p = realloc(ptr, size);
    if (p == NULL) {
        fprintf(stderr, "Out of memory\n");
        exit(1);
    }
    return p;
}
#endif /* !PCC_REALLOC */

#ifndef PCC_FREE
#define PCC_FREE(auxil, ptr) free(ptr)
#endif /* !PCC_FREE */

static char *pcc_strndup_e(pcc_auxil_t auxil, const char *str, size_t len) {
    const size_t m = strnlen(str, len);
    char *const s = (char *)PCC_MALLOC(auxil, m + 1);
    memcpy(s, str, m);
    s[m] = '\0';
    return s;
}

static void pcc_char_array__init(pcc_auxil_t auxil, pcc_char_array_t *array, int max) {
    array->len = 0;
    array->max = max;
    array->buf = (char *)PCC_MALLOC(auxil, array->max);
}

static void pcc_char_array__add(pcc_auxil_t auxil, pcc_char_array_t *array, char ch) {
    if (array->max <= 0) array->max = 1;
    while (array->max <= array->len) array->max <<= 1;
    array->buf = (char *)PCC_REALLOC(auxil, array->buf, array->max);
    array->buf[array->len++] = ch;
}

static void pcc_char_array__term(pcc_auxil_t auxil, pcc_char_array_t *array) {
    PCC_FREE(auxil, array->buf);
}

static void pcc_value_table__init(pcc_auxil_t auxil, pcc_value_table_t *table, int max) {
    table->len = 0;
    table->max = max;
    table->buf = (pcc_value_t *)PCC_MALLOC(auxil, table->max * sizeof(pcc_value_t));
}

static void pcc_value_table__resize(pcc_auxil_t auxil, pcc_value_table_t *table, int len) {
    if (table->max < len) {
        if (table->max <= 0) table->max = 1;
        while (table->max < len) table->max <<= 1;
        table->buf = (pcc_value_t *)PCC_REALLOC(auxil, table->buf, table->max * sizeof(pcc_value_t));
    }
    table->len = len;
}

static void pcc_value_table__term(pcc_auxil_t auxil, pcc_value_table_t *table) {
    PCC_FREE(auxil, table->buf);
}

static void pcc_value_refer_table__init(pcc_auxil_t auxil, pcc_value_refer_table_t *table, int max) {
    table->len = 0;
    table->max = max;
    table->buf = (pcc_value_t **)PCC_MALLOC(auxil, table->max * sizeof(pcc_value_t *));
}

static void pcc_value_refer_table__resize(pcc_auxil_t auxil, pcc_value_refer_table_t *table, int len) {
    int i;
    if (table->max < len) {
        if (table->max <= 0) table->max = 1;
        while (table->max < len) table->max <<= 1;
        table->buf = (pcc_value_t **)PCC_REALLOC(auxil, table->buf, table->max * sizeof(pcc_value_t *));
    }
    for (i = table->len; i < len; i++) table->buf[i] = NULL;
    table->len = len;
}

static void pcc_value_refer_table__term(pcc_auxil_t auxil, pcc_value_refer_table_t *table) {
    PCC_FREE(auxil, table->buf);
}

static void pcc_capture_table__init(pcc_auxil_t auxil, pcc_capture_table_t *table, int max) {
    table->len = 0;
    table->max = max;
    table->buf = (pcc_capture_t *)PCC_MALLOC(auxil, table->max * sizeof(pcc_capture_t));
}

static void pcc_capture_table__resize(pcc_auxil_t auxil, pcc_capture_table_t *table, int len) {
    int i;
    for (i = table->len - 1; i >= len; i--) PCC_FREE(auxil, table->buf[i].string);
    if (table->max < len) {
        if (table->max <= 0) table->max = 1;
        while (table->max < len) table->max <<= 1;
        table->buf = (pcc_capture_t *)PCC_REALLOC(auxil, table->buf, table->max * sizeof(pcc_capture_t));
    }
    for (i = table->len; i < len; i++) {
        table->buf[i].range.start = 0;
        table->buf[i].range.end = 0;
        table->buf[i].string = NULL;
    }
    table->len = len;
}

static void pcc_capture_table__term(pcc_auxil_t auxil, pcc_capture_table_t *table) {
    int i;
    for (i = table->len - 1; i >= 0; i--) PCC_FREE(auxil, table->buf[i].string);
    PCC_FREE(auxil, table->buf);
}

static void pcc_capture_const_table__init(pcc_auxil_t auxil, pcc_capture_const_table_t *table, int max) {
    table->len = 0;
    table->max = max;
    table->buf = (const pcc_capture_t **)PCC_MALLOC(auxil, table->max * sizeof(const pcc_capture_t *));
}

static void pcc_capture_const_table__resize(pcc_auxil_t auxil, pcc_capture_const_table_t *table, int len) {
    int i;
    if (table->max < len) {
        if (table->max <= 0) table->max = 1;
        while (table->max < len) table->max <<= 1;
        table->buf = (const pcc_capture_t **)PCC_REALLOC(auxil, (pcc_capture_t **)table->buf, table->max * sizeof(const pcc_capture_t *));
    }
    for (i = table->len; i < len; i++) table->buf[i] = NULL;
    table->len = len;
}

static void pcc_capture_const_table__term(pcc_auxil_t auxil, pcc_capture_const_table_t *table) {
    PCC_FREE(auxil, (pcc_capture_t **)table->buf);
}

static pcc_thunk_t *pcc_thunk__create_leaf(pcc_auxil_t auxil, pcc_action_t action, int valuec, int captc) {
    pcc_thunk_t *const thunk = (pcc_thunk_t *)PCC_MALLOC(auxil, sizeof(pcc_thunk_t));
    thunk->type = PCC_THUNK_LEAF;
    pcc_value_refer_table__init(auxil, &thunk->data.leaf.values, valuec);
    pcc_value_refer_table__resize(auxil, &thunk->data.leaf.values, valuec);
    pcc_capture_const_table__init(auxil, &thunk->data.leaf.capts, captc);
    pcc_capture_const_table__resize(auxil, &thunk->data.leaf.capts, captc);
    thunk->data.leaf.capt0.range.start = 0;
    thunk->data.leaf.capt0.range.end = 0;
    thunk->data.leaf.capt0.string = NULL;
    thunk->data.leaf.action = action;
    return thunk;
}

static pcc_thunk_t *pcc_thunk__create_node(pcc_auxil_t auxil, const pcc_thunk_array_t *thunks, pcc_value_t *value) {
    pcc_thunk_t *const thunk = (pcc_thunk_t *)PCC_MALLOC(auxil, sizeof(pcc_thunk_t));
    thunk->type = PCC_THUNK_NODE;
    thunk->data.node.thunks = thunks;
    thunk->data.node.value = value;
    return thunk;
}

static void pcc_thunk__destroy(pcc_auxil_t auxil, pcc_thunk_t *thunk) {
    if (thunk == NULL) return;
    switch (thunk->type) {
    case PCC_THUNK_LEAF:
        PCC_FREE(auxil, thunk->data.leaf.capt0.string);
        pcc_capture_const_table__term(auxil, &thunk->data.leaf.capts);
        pcc_value_refer_table__term(auxil, &thunk->data.leaf.values);
        break;
    case PCC_THUNK_NODE:
        break;
    default: /* unknown */
        break;
    }
    PCC_FREE(auxil, thunk);
}

static void pcc_thunk_array__init(pcc_auxil_t auxil, pcc_thunk_array_t *array, int max) {
    array->len = 0;
    array->max = max;
    array->buf = (pcc_thunk_t **)PCC_MALLOC(auxil, array->max * sizeof(pcc_thunk_t *));
}

static void pcc_thunk_array__add(pcc_auxil_t auxil, pcc_thunk_array_t *array, pcc_thunk_t *thunk) {
    if (array->max <= 0) array->max = 1;
    while (array->max <= array->len) array->max <<= 1;
    array->buf = (pcc_thunk_t **)PCC_REALLOC(auxil, array->buf, array->max * sizeof(pcc_thunk_t *));
    array->buf[array->len++] = thunk;
}

static void pcc_thunk_array__revert(pcc_auxil_t auxil, pcc_thunk_array_t *array, int len) {
    if (array->len > len) {
        int i;
        for (i = array->len - 1; i >= len; i--) pcc_thunk__destroy(auxil, array->buf[i]);
        array->len = len;
    }
}

static void pcc_thunk_array__term(pcc_auxil_t auxil, pcc_thunk_array_t *array) {
    int i;
    for (i = array->len - 1; i >= 0; i--) pcc_thunk__destroy(auxil, array->buf[i]);
    PCC_FREE(auxil, array->buf);
}

static pcc_thunk_chunk_t *pcc_thunk_chunk__create(pcc_auxil_t auxil) {
    pcc_thunk_chunk_t *const chunk = (pcc_thunk_chunk_t *)PCC_MALLOC(auxil, sizeof(pcc_thunk_chunk_t));
    pcc_value_table__init(auxil, &chunk->values, PCC_ARRAYSIZE);
    pcc_capture_table__init(auxil, &chunk->capts, PCC_ARRAYSIZE);
    pcc_thunk_array__init(auxil, &chunk->thunks, PCC_ARRAYSIZE);
    chunk->pos = 0;
    return chunk;
}

static void pcc_thunk_chunk__destroy(pcc_auxil_t auxil, pcc_thunk_chunk_t *chunk) {
    if (chunk == NULL) return;
    pcc_thunk_array__term(auxil, &chunk->thunks);
    pcc_capture_table__term(auxil, &chunk->capts);
    pcc_value_table__term(auxil, &chunk->values);
    PCC_FREE(auxil, chunk);
}

static void pcc_rule_set__init(pcc_auxil_t auxil, pcc_rule_set_t *set, int max) {
    set->len = 0;
    set->max = max;
    set->buf = (pcc_rule_t *)PCC_MALLOC(auxil, set->max * sizeof(pcc_rule_t));
}

static int pcc_rule_set__index(pcc_auxil_t auxil, const pcc_rule_set_t *set, pcc_rule_t rule) {
    int i;
    for (i = 0; i < set->len; i++) {
        if (set->buf[i] == rule) return i;
    }
    return -1;
}

static pcc_bool_t pcc_rule_set__add(pcc_auxil_t auxil, pcc_rule_set_t *set, pcc_rule_t rule) {
    const int i = pcc_rule_set__index(auxil, set, rule);
    if (i >= 0) return PCC_FALSE;
    if (set->max <= 0) set->max = 1;
    while (set->max <= set->len) set->max <<= 1;
    set->buf = (pcc_rule_t *)PCC_REALLOC(auxil, set->buf, set->max * sizeof(pcc_rule_t));
    set->buf[set->len++] = rule;
    return PCC_TRUE;
}

static pcc_bool_t pcc_rule_set__remove(pcc_auxil_t auxil, pcc_rule_set_t *set, pcc_rule_t rule) {
    const int i = pcc_rule_set__index(auxil, set, rule);
    if (i < 0) return PCC_FALSE;
    memmove(set->buf + i, set->buf + (i + 1), (set->len - (i + 1)) * sizeof(pcc_rule_t));
    return PCC_TRUE;
}

static void pcc_rule_set__clear(pcc_auxil_t auxil, pcc_rule_set_t *set) {
    set->len = 0;
}

static void pcc_rule_set__copy(pcc_auxil_t auxil, pcc_rule_set_t *set, const pcc_rule_set_t *src) {
    int i;
    pcc_rule_set__clear(auxil, set);
    for (i = 0; i < src->len; i++) {
        pcc_rule_set__add(auxil, set, src->buf[i]);
    }
}

static void pcc_rule_set__term(pcc_auxil_t auxil, pcc_rule_set_t *set) {
    PCC_FREE(auxil, set->buf);
}

static pcc_lr_head_t *pcc_lr_head__create(pcc_auxil_t auxil, pcc_rule_t rule) {
    pcc_lr_head_t *const head = (pcc_lr_head_t *)PCC_MALLOC(auxil, sizeof(pcc_lr_head_t));
    head->rule = rule;
    pcc_rule_set__init(auxil, &head->invol, PCC_ARRAYSIZE);
    pcc_rule_set__init(auxil, &head->eval, PCC_ARRAYSIZE);
    head->hold = NULL;
    return head;
}

static void pcc_lr_head__destroy(pcc_auxil_t auxil, pcc_lr_head_t *head) {
    if (head == NULL) return;
    pcc_lr_head__destroy(auxil, head->hold);
    pcc_rule_set__term(auxil, &head->eval);
    pcc_rule_set__term(auxil, &head->invol);
    PCC_FREE(auxil, head);
}

static void pcc_lr_entry__destroy(pcc_auxil_t auxil, pcc_lr_entry_t *lr);

static pcc_lr_answer_t *pcc_lr_answer__create(pcc_auxil_t auxil, pcc_lr_answer_type_t type, int pos) {
    pcc_lr_answer_t *answer = (pcc_lr_answer_t *)PCC_MALLOC(auxil, sizeof(pcc_lr_answer_t));
    answer->type = type;
    answer->pos = pos;
    answer->hold = NULL;
    switch (answer->type) {
    case PCC_LR_ANSWER_LR:
        answer->data.lr = NULL;
        break;
    case PCC_LR_ANSWER_CHUNK:
        answer->data.chunk = NULL;
        break;
    default: /* unknown */
        PCC_FREE(auxil, answer);
        answer = NULL;
    }
    return answer;
}

static void pcc_lr_answer__set_chunk(pcc_auxil_t auxil, pcc_lr_answer_t *answer, pcc_thunk_chunk_t *chunk) {
    pcc_lr_answer_t *const a = pcc_lr_answer__create(auxil, answer->type, answer->pos);
    switch (answer->type) {
    case PCC_LR_ANSWER_LR:
        a->data.lr = answer->data.lr;
        break;
    case PCC_LR_ANSWER_CHUNK:
        a->data.chunk = answer->data.chunk;
        break;
    default: /* unknown */
        break;
    }
    a->hold = answer->hold;
    answer->hold = a;
    answer->type = PCC_LR_ANSWER_CHUNK;
    answer->data.chunk = chunk;
}

static void pcc_lr_answer__destroy(pcc_auxil_t auxil, pcc_lr_answer_t *answer) {
    if (answer == NULL) return;
    pcc_lr_answer__destroy(auxil, answer->hold);
    switch (answer->type) {
    case PCC_LR_ANSWER_LR:
        pcc_lr_entry__destroy(auxil, answer->data.lr);
        break;
    case PCC_LR_ANSWER_CHUNK:
        pcc_thunk_chunk__destroy(auxil, answer->data.chunk);
        break;
    default: /* unknown */
        break;
    }
    PCC_FREE(auxil, answer);
}

static void pcc_lr_memo_map__init(pcc_auxil_t auxil, pcc_lr_memo_map_t *map, int max) {
    map->len = 0;
    map->max = max;
    map->buf = (pcc_lr_memo_t *)PCC_MALLOC(auxil, map->max * sizeof(pcc_lr_memo_t));
}

static int pcc_lr_memo_map__index(pcc_auxil_t auxil, pcc_lr_memo_map_t *map, pcc_rule_t rule) {
    int i;
    for (i = 0; i < map->len; i++) {
        if (map->buf[i].rule == rule) return i;
    }
    return -1;
}

static void pcc_lr_memo_map__put(pcc_auxil_t auxil, pcc_lr_memo_map_t *map, pcc_rule_t rule, pcc_lr_answer_t *answer) {
    const int i = pcc_lr_memo_map__index(auxil, map, rule);
    if (i >= 0) {
        pcc_lr_answer__destroy(auxil, map->buf[i].answer);
        map->buf[i].answer = answer;
    }
    else {
        if (map->max <= 0) map->max = 1;
        while (map->max <= map->len) map->max <<= 1;
        map->buf = (pcc_lr_memo_t *)PCC_REALLOC(auxil, map->buf, map->max * sizeof(pcc_lr_memo_t));
        map->buf[map->len].rule = rule;
        map->buf[map->len].answer = answer;
        map->len++;
    }
}

static pcc_lr_answer_t *pcc_lr_memo_map__get(pcc_auxil_t auxil, pcc_lr_memo_map_t *map, pcc_rule_t rule) {
    const int i = pcc_lr_memo_map__index(auxil, map, rule);
    return (i >= 0) ? map->buf[i].answer : NULL;
}

static void pcc_lr_memo_map__term(pcc_auxil_t auxil, pcc_lr_memo_map_t *map) {
    int i;
    for (i = map->len - 1; i >= 0; i--) pcc_lr_answer__destroy(auxil, map->buf[i].answer);
    PCC_FREE(auxil, map->buf);
}

static pcc_lr_table_entry_t *pcc_lr_table_entry__create(pcc_auxil_t auxil) {
    pcc_lr_table_entry_t *const entry = (pcc_lr_table_entry_t *)PCC_MALLOC(auxil, sizeof(pcc_lr_table_entry_t));
    entry->head = NULL;
    pcc_lr_memo_map__init(auxil, &entry->memos, PCC_ARRAYSIZE);
    entry->hold_a = NULL;
    entry->hold_h = NULL;
    return entry;
}

static void pcc_lr_table_entry__destroy(pcc_auxil_t auxil, pcc_lr_table_entry_t *entry) {
    if (entry == NULL) return;
    pcc_lr_head__destroy(auxil, entry->hold_h);
    pcc_lr_answer__destroy(auxil, entry->hold_a);
    pcc_lr_memo_map__term(auxil, &entry->memos);
    PCC_FREE(auxil, entry);
}

static void pcc_lr_table__init(pcc_auxil_t auxil, pcc_lr_table_t *table, int max) {
    table->len = 0;
    table->max = max;
    table->buf = (pcc_lr_table_entry_t **)PCC_MALLOC(auxil, table->max * sizeof(pcc_lr_table_entry_t *));
}

static void pcc_lr_table__resize(pcc_auxil_t auxil, pcc_lr_table_t *table, int len) {
    int i;
    for (i = table->len - 1; i >= len; i--) pcc_lr_table_entry__destroy(auxil, table->buf[i]);
    if (table->max < len) {
        if (table->max <= 0) table->max = 1;
        while (table->max < len) table->max <<= 1;
        table->buf = (pcc_lr_table_entry_t **)PCC_REALLOC(auxil, table->buf, table->max * sizeof(pcc_lr_table_entry_t *));
    }
    for (i = table->len; i < len; i++) table->buf[i] = NULL;
    table->len = len;
}

static void pcc_lr_table__set_head(pcc_auxil_t auxil, pcc_lr_table_t *table, int index, pcc_lr_head_t *head) {
    if (index >= table->len) pcc_lr_table__resize(auxil, table, index + 1);
    if (table->buf[index] == NULL) table->buf[index] = pcc_lr_table_entry__create(auxil);
    table->buf[index]->head = head;
}

static void pcc_lr_table__hold_head(pcc_auxil_t auxil, pcc_lr_table_t *table, int index, pcc_lr_head_t *head) {
    if (index >= table->len) pcc_lr_table__resize(auxil, table, index + 1);
    if (table->buf[index] == NULL) table->buf[index] = pcc_lr_table_entry__create(auxil);
    head->hold = table->buf[index]->hold_h;
    table->buf[index]->hold_h = head;
}

static void pcc_lr_table__set_answer(pcc_auxil_t auxil, pcc_lr_table_t *table, int index, pcc_rule_t rule, pcc_lr_answer_t *answer) {
    if (index >= table->len) pcc_lr_table__resize(auxil, table, index + 1);
    if (table->buf[index] == NULL) table->buf[index] = pcc_lr_table_entry__create(auxil);
    pcc_lr_memo_map__put(auxil, &table->buf[index]->memos, rule, answer);
}

static void pcc_lr_table__hold_answer(pcc_auxil_t auxil, pcc_lr_table_t *table, int index, pcc_lr_answer_t *answer) {
    if (index >= table->len) pcc_lr_table__resize(auxil, table, index + 1);
    if (table->buf[index] == NULL) table->buf[index] = pcc_lr_table_entry__create(auxil);
    answer->hold = table->buf[index]->hold_a;
    table->buf[index]->hold_a = answer;
}

static pcc_lr_head_t *pcc_lr_table__get_head(pcc_auxil_t auxil, pcc_lr_table_t *table, int index) {
    if (index >= table->len || table->buf[index] == NULL) return NULL;
    return table->buf[index]->head;
}

static pcc_lr_answer_t *pcc_lr_table__get_answer(pcc_auxil_t auxil, pcc_lr_table_t *table, int index, pcc_rule_t rule) {
    if (index >= table->len || table->buf[index] == NULL) return NULL;
    return pcc_lr_memo_map__get(auxil, &table->buf[index]->memos, rule);
}

static void pcc_lr_table__shift(pcc_auxil_t auxil, pcc_lr_table_t *table, int count) {
    int i;
    if (count > table->len) count = table->len;
    for (i = 0; i < count; i++) pcc_lr_table_entry__destroy(auxil, table->buf[i]);
    memmove(table->buf, table->buf + count, (table->len - count) * sizeof(pcc_lr_table_entry_t *));
    table->len -= count;
}

static void pcc_lr_table__term(pcc_auxil_t auxil, pcc_lr_table_t *table) {
    int i;
    for (i = table->len - 1; i >= 0; i--) pcc_lr_table_entry__destroy(auxil, table->buf[i]);
    PCC_FREE(auxil, table->buf);
}

static pcc_lr_entry_t *pcc_lr_entry__create(pcc_auxil_t auxil, pcc_rule_t rule) {
    pcc_lr_entry_t *const lr = (pcc_lr_entry_t *)PCC_MALLOC(auxil, sizeof(pcc_lr_entry_t));
    lr->rule = rule;
    lr->seed = NULL;
    lr->head = NULL;
    return lr;
}

static void pcc_lr_entry__destroy(pcc_auxil_t auxil, pcc_lr_entry_t *lr) {
    PCC_FREE(auxil, lr);
}

static void pcc_lr_stack__init(pcc_auxil_t auxil, pcc_lr_stack_t *stack, int max) {
    stack->len = 0;
    stack->max = max;
    stack->buf = (pcc_lr_entry_t **)PCC_MALLOC(auxil, stack->max * sizeof(pcc_lr_entry_t *));
}

static void pcc_lr_stack__push(pcc_auxil_t auxil, pcc_lr_stack_t *stack, pcc_lr_entry_t *lr) {
    if (stack->max <= 0) stack->max = 1;
    while (stack->max <= stack->len) stack->max <<= 1;
    stack->buf = (pcc_lr_entry_t **)PCC_REALLOC(auxil, stack->buf, stack->max * sizeof(pcc_lr_entry_t *));
    stack->buf[stack->len++] = lr;
}

static pcc_lr_entry_t *pcc_lr_stack__pop(pcc_auxil_t auxil, pcc_lr_stack_t *stack) {
    return stack->buf[--stack->len];
}

static void pcc_lr_stack__term(pcc_auxil_t auxil, pcc_lr_stack_t *stack) {
    PCC_FREE(auxil, stack->buf);
}

static mstro_stp_context_t *pcc_context__create(pcc_auxil_t auxil) {
    mstro_stp_context_t *const ctx = (mstro_stp_context_t *)PCC_MALLOC(auxil, sizeof(mstro_stp_context_t));
    ctx->pos = 0;
    pcc_char_array__init(auxil, &ctx->buffer, PCC_BUFFERSIZE);
    pcc_lr_table__init(auxil, &ctx->lrtable, PCC_BUFFERSIZE);
    pcc_lr_stack__init(auxil, &ctx->lrstack, PCC_ARRAYSIZE);
    ctx->auxil = auxil;
    return ctx;
}

static void pcc_context__destroy(mstro_stp_context_t *ctx) {
    if (ctx == NULL) return;
    pcc_lr_stack__term(ctx->auxil, &ctx->lrstack);
    pcc_lr_table__term(ctx->auxil, &ctx->lrtable);
    pcc_char_array__term(ctx->auxil, &ctx->buffer);
    PCC_FREE(ctx->auxil, ctx);
}

static int pcc_refill_buffer(mstro_stp_context_t *ctx, int num) {
    int n, c;
    n = ctx->buffer.len - ctx->pos;
    if (n >= num) return n;
    while (ctx->buffer.len < ctx->pos + num) {
        c = PCC_GETCHAR(ctx->auxil);
        if (c == EOF) break;
        pcc_char_array__add(ctx->auxil, &ctx->buffer, (char)c);
    }
    return ctx->buffer.len - ctx->pos;
}

static void pcc_commit_buffer(mstro_stp_context_t *ctx) {
    memmove(ctx->buffer.buf, ctx->buffer.buf + ctx->pos, ctx->buffer.len - ctx->pos);
    ctx->buffer.len -= ctx->pos;
    pcc_lr_table__shift(ctx->auxil, &ctx->lrtable, ctx->pos);
    ctx->pos = 0;
}

static const char *pcc_get_capture_string(mstro_stp_context_t *ctx, const pcc_capture_t *capt) {
    if (capt->string == NULL)
        ((pcc_capture_t *)capt)->string =
            pcc_strndup_e(ctx->auxil, ctx->buffer.buf + capt->range.start, capt->range.end - capt->range.start);
    return capt->string;
}

static pcc_bool_t pcc_apply_rule(mstro_stp_context_t *ctx, pcc_rule_t rule, pcc_thunk_array_t *thunks, pcc_value_t *value) {
    static pcc_value_t null;
    pcc_thunk_chunk_t *c = NULL;
    const int p = ctx->pos;
    pcc_bool_t b = PCC_TRUE;
    pcc_lr_answer_t *a = pcc_lr_table__get_answer(ctx->auxil, &ctx->lrtable, p, rule);
    pcc_lr_head_t *h = pcc_lr_table__get_head(ctx->auxil, &ctx->lrtable, p);
    if (h != NULL) {
        if (a == NULL && rule != h->rule && pcc_rule_set__index(ctx->auxil, &h->invol, rule) < 0) {
            b = PCC_FALSE;
            c = NULL;
        }
        else if (pcc_rule_set__remove(ctx->auxil, &h->eval, rule)) {
            b = PCC_FALSE;
            c = rule(ctx);
            a = pcc_lr_answer__create(ctx->auxil, PCC_LR_ANSWER_CHUNK, ctx->pos);
            a->data.chunk = c;
            pcc_lr_table__hold_answer(ctx->auxil, &ctx->lrtable, p, a);
        }
    }
    if (b) {
        if (a != NULL) {
            ctx->pos = a->pos;
            switch (a->type) {
            case PCC_LR_ANSWER_LR:
                if (a->data.lr->head == NULL) {
                    a->data.lr->head = pcc_lr_head__create(ctx->auxil, rule);
                    pcc_lr_table__hold_head(ctx->auxil, &ctx->lrtable, p, a->data.lr->head);
                }
                {
                    int i;
                    for (i = ctx->lrstack.len - 1; i >= 0; i--) {
                        if (ctx->lrstack.buf[i]->head == a->data.lr->head) break;
                        ctx->lrstack.buf[i]->head = a->data.lr->head;
                        pcc_rule_set__add(ctx->auxil, &a->data.lr->head->invol, ctx->lrstack.buf[i]->rule);
                    }
                }
                c = a->data.lr->seed;
                break;
            case PCC_LR_ANSWER_CHUNK:
                c = a->data.chunk;
                break;
            default: /* unknown */
                break;
            }
        }
        else {
            pcc_lr_entry_t *const e = pcc_lr_entry__create(ctx->auxil, rule);
            pcc_lr_stack__push(ctx->auxil, &ctx->lrstack, e);
            a = pcc_lr_answer__create(ctx->auxil, PCC_LR_ANSWER_LR, p);
            a->data.lr = e;
            pcc_lr_table__set_answer(ctx->auxil, &ctx->lrtable, p, rule, a);
            c = rule(ctx);
            pcc_lr_stack__pop(ctx->auxil, &ctx->lrstack);
            a->pos = ctx->pos;
            if (e->head == NULL) {
                pcc_lr_answer__set_chunk(ctx->auxil, a, c);
            }
            else {
                e->seed = c;
                h = a->data.lr->head;
                if (h->rule != rule) {
                    c = a->data.lr->seed;
                    a = pcc_lr_answer__create(ctx->auxil, PCC_LR_ANSWER_CHUNK, ctx->pos);
                    a->data.chunk = c;
                    pcc_lr_table__hold_answer(ctx->auxil, &ctx->lrtable, p, a);
                }
                else {
                    pcc_lr_answer__set_chunk(ctx->auxil, a, a->data.lr->seed);
                    if (a->data.chunk == NULL) {
                        c = NULL;
                    }
                    else {
                        pcc_lr_table__set_head(ctx->auxil, &ctx->lrtable, p, h);
                        for (;;) {
                            ctx->pos = p;
                            pcc_rule_set__copy(ctx->auxil, &h->eval, &h->invol);
                            c = rule(ctx);
                            if (c == NULL || ctx->pos <= a->pos) break;
                            pcc_lr_answer__set_chunk(ctx->auxil, a, c);
                            a->pos = ctx->pos;
                        }
                        pcc_thunk_chunk__destroy(ctx->auxil, c);
                        pcc_lr_table__set_head(ctx->auxil, &ctx->lrtable, p, NULL);
                        ctx->pos = a->pos;
                        c = a->data.chunk;
                    }
                }
            }
        }
    }
    if (c == NULL) return PCC_FALSE;
    if (value == NULL) value = &null;
    memset(value, 0, sizeof(pcc_value_t)); /* in case */
    pcc_thunk_array__add(ctx->auxil, thunks, pcc_thunk__create_node(ctx->auxil, &c->thunks, value));
    return PCC_TRUE;
}

static void pcc_do_action(mstro_stp_context_t *ctx, const pcc_thunk_array_t *thunks, pcc_value_t *value) {
    int i;
    for (i = 0; i < thunks->len; i++) {
        pcc_thunk_t *const thunk = thunks->buf[i];
        switch (thunk->type) {
        case PCC_THUNK_LEAF:
            thunk->data.leaf.action(ctx, thunk, value);
            break;
        case PCC_THUNK_NODE:
            pcc_do_action(ctx, thunk->data.node.thunks, thunk->data.node.value);
            break;
        default: /* unknown */
            break;
        }
    }
}

static void pcc_action_type_expression_0(mstro_stp_context_t *__pcc_ctx, pcc_thunk_t *__pcc_in, pcc_value_t *__pcc_out) {
#define auxil (__pcc_ctx->auxil)
#define __ (*__pcc_out)
#define t (*__pcc_in->data.leaf.values.buf[0])
#define _0 pcc_get_capture_string(__pcc_ctx, &__pcc_in->data.leaf.capt0)
#define _0s ((const)__pcc_in->data.leaf.capt0.range.start)
#define _0e ((const)__pcc_in->data.leaf.capt0.range.end)
    __ = t;
    mstro_stp_val__describe(__);
#undef _0e
#undef _0s
#undef _0
#undef t
#undef __
#undef auxil
}

static void pcc_action_restricted_type_0(mstro_stp_context_t *__pcc_ctx, pcc_thunk_t *__pcc_in, pcc_value_t *__pcc_out) {
#define auxil (__pcc_ctx->auxil)
#define __ (*__pcc_out)
#define n (*__pcc_in->data.leaf.values.buf[0])
#define args (*__pcc_in->data.leaf.values.buf[1])
#define _0 pcc_get_capture_string(__pcc_ctx, &__pcc_in->data.leaf.capt0)
#define _0s ((const)__pcc_in->data.leaf.capt0.range.start)
#define _0e ((const)__pcc_in->data.leaf.capt0.range.end)
    /* extract the arguments applicable to type, cleaning up unused ones */
    __=mstro_stp_val__build_restricted_type(n,args);
#undef _0e
#undef _0s
#undef _0
#undef args
#undef n
#undef __
#undef auxil
}

static void pcc_action_type_name_0(mstro_stp_context_t *__pcc_ctx, pcc_thunk_t *__pcc_in, pcc_value_t *__pcc_out) {
#define auxil (__pcc_ctx->auxil)
#define __ (*__pcc_out)
#define x (*__pcc_in->data.leaf.values.buf[0])
#define _0 pcc_get_capture_string(__pcc_ctx, &__pcc_in->data.leaf.capt0)
#define _0s ((const)__pcc_in->data.leaf.capt0.range.start)
#define _0e ((const)__pcc_in->data.leaf.capt0.range.end)
    __ = x; 
#undef _0e
#undef _0s
#undef _0
#undef x
#undef __
#undef auxil
}

static void pcc_action_type_name_1(mstro_stp_context_t *__pcc_ctx, pcc_thunk_t *__pcc_in, pcc_value_t *__pcc_out) {
#define auxil (__pcc_ctx->auxil)
#define __ (*__pcc_out)
#define x (*__pcc_in->data.leaf.values.buf[0])
#define _0 pcc_get_capture_string(__pcc_ctx, &__pcc_in->data.leaf.capt0)
#define _0s ((const)__pcc_in->data.leaf.capt0.range.start)
#define _0e ((const)__pcc_in->data.leaf.capt0.range.end)
    __ = x; 
#undef _0e
#undef _0s
#undef _0
#undef x
#undef __
#undef auxil
}

static void pcc_action_builtin_type_name_0(mstro_stp_context_t *__pcc_ctx, pcc_thunk_t *__pcc_in, pcc_value_t *__pcc_out) {
#define auxil (__pcc_ctx->auxil)
#define __ (*__pcc_out)
#define _0 pcc_get_capture_string(__pcc_ctx, &__pcc_in->data.leaf.capt0)
#define _0s ((const)__pcc_in->data.leaf.capt0.range.start)
#define _0e ((const)__pcc_in->data.leaf.capt0.range.end)
    __ = mstro_stp_val_alloc(MSTRO_STP_BOOL);   DEBUG("found bool\n");  
#undef _0e
#undef _0s
#undef _0
#undef __
#undef auxil
}

static void pcc_action_builtin_type_name_1(mstro_stp_context_t *__pcc_ctx, pcc_thunk_t *__pcc_in, pcc_value_t *__pcc_out) {
#define auxil (__pcc_ctx->auxil)
#define __ (*__pcc_out)
#define _0 pcc_get_capture_string(__pcc_ctx, &__pcc_in->data.leaf.capt0)
#define _0s ((const)__pcc_in->data.leaf.capt0.range.start)
#define _0e ((const)__pcc_in->data.leaf.capt0.range.end)
    __ = mstro_stp_val_alloc(MSTRO_STP_UINT);   DEBUG("found uint\n");  
#undef _0e
#undef _0s
#undef _0
#undef __
#undef auxil
}

static void pcc_action_builtin_type_name_2(mstro_stp_context_t *__pcc_ctx, pcc_thunk_t *__pcc_in, pcc_value_t *__pcc_out) {
#define auxil (__pcc_ctx->auxil)
#define __ (*__pcc_out)
#define _0 pcc_get_capture_string(__pcc_ctx, &__pcc_in->data.leaf.capt0)
#define _0s ((const)__pcc_in->data.leaf.capt0.range.start)
#define _0e ((const)__pcc_in->data.leaf.capt0.range.end)
    __ = mstro_stp_val_alloc(MSTRO_STP_INT);    DEBUG("found int\n");   
#undef _0e
#undef _0s
#undef _0
#undef __
#undef auxil
}

static void pcc_action_builtin_type_name_3(mstro_stp_context_t *__pcc_ctx, pcc_thunk_t *__pcc_in, pcc_value_t *__pcc_out) {
#define auxil (__pcc_ctx->auxil)
#define __ (*__pcc_out)
#define _0 pcc_get_capture_string(__pcc_ctx, &__pcc_in->data.leaf.capt0)
#define _0s ((const)__pcc_in->data.leaf.capt0.range.start)
#define _0e ((const)__pcc_in->data.leaf.capt0.range.end)
    __ = mstro_stp_val_alloc(MSTRO_STP_FLOAT);  DEBUG("found float\n"); 
#undef _0e
#undef _0s
#undef _0
#undef __
#undef auxil
}

static void pcc_action_builtin_type_name_4(mstro_stp_context_t *__pcc_ctx, pcc_thunk_t *__pcc_in, pcc_value_t *__pcc_out) {
#define auxil (__pcc_ctx->auxil)
#define __ (*__pcc_out)
#define _0 pcc_get_capture_string(__pcc_ctx, &__pcc_in->data.leaf.capt0)
#define _0s ((const)__pcc_in->data.leaf.capt0.range.start)
#define _0e ((const)__pcc_in->data.leaf.capt0.range.end)
    __ = mstro_stp_val_alloc(MSTRO_STP_DOUBLE); DEBUG("found double\n");
#undef _0e
#undef _0s
#undef _0
#undef __
#undef auxil
}

static void pcc_action_builtin_type_name_5(mstro_stp_context_t *__pcc_ctx, pcc_thunk_t *__pcc_in, pcc_value_t *__pcc_out) {
#define auxil (__pcc_ctx->auxil)
#define __ (*__pcc_out)
#define _0 pcc_get_capture_string(__pcc_ctx, &__pcc_in->data.leaf.capt0)
#define _0s ((const)__pcc_in->data.leaf.capt0.range.start)
#define _0e ((const)__pcc_in->data.leaf.capt0.range.end)
    __ = mstro_stp_val_alloc(MSTRO_STP_REGEX);  DEBUG("found regex\n"); 
#undef _0e
#undef _0s
#undef _0
#undef __
#undef auxil
}

static void pcc_action_builtin_type_name_6(mstro_stp_context_t *__pcc_ctx, pcc_thunk_t *__pcc_in, pcc_value_t *__pcc_out) {
#define auxil (__pcc_ctx->auxil)
#define __ (*__pcc_out)
#define _0 pcc_get_capture_string(__pcc_ctx, &__pcc_in->data.leaf.capt0)
#define _0s ((const)__pcc_in->data.leaf.capt0.range.start)
#define _0e ((const)__pcc_in->data.leaf.capt0.range.end)
    __ = mstro_stp_val_alloc(MSTRO_STP_STR);    DEBUG("found str\n");   
#undef _0e
#undef _0s
#undef _0
#undef __
#undef auxil
}

static void pcc_action_builtin_type_name_7(mstro_stp_context_t *__pcc_ctx, pcc_thunk_t *__pcc_in, pcc_value_t *__pcc_out) {
#define auxil (__pcc_ctx->auxil)
#define __ (*__pcc_out)
#define _0 pcc_get_capture_string(__pcc_ctx, &__pcc_in->data.leaf.capt0)
#define _0s ((const)__pcc_in->data.leaf.capt0.range.start)
#define _0e ((const)__pcc_in->data.leaf.capt0.range.end)
    __ = mstro_stp_val_alloc(MSTRO_STP_BLOB);   DEBUG("found blob\n");  
#undef _0e
#undef _0s
#undef _0
#undef __
#undef auxil
}

static void pcc_action_builtin_type_name_8(mstro_stp_context_t *__pcc_ctx, pcc_thunk_t *__pcc_in, pcc_value_t *__pcc_out) {
#define auxil (__pcc_ctx->auxil)
#define __ (*__pcc_out)
#define _0 pcc_get_capture_string(__pcc_ctx, &__pcc_in->data.leaf.capt0)
#define _0s ((const)__pcc_in->data.leaf.capt0.range.start)
#define _0e ((const)__pcc_in->data.leaf.capt0.range.end)
    __ = mstro_stp_val_alloc(MSTRO_STP_TIMESTAMP); DEBUG("found timestamp\n"); 
#undef _0e
#undef _0s
#undef _0
#undef __
#undef auxil
}

static void pcc_action_builtin_type_name_9(mstro_stp_context_t *__pcc_ctx, pcc_thunk_t *__pcc_in, pcc_value_t *__pcc_out) {
#define auxil (__pcc_ctx->auxil)
#define __ (*__pcc_out)
#define _0 pcc_get_capture_string(__pcc_ctx, &__pcc_in->data.leaf.capt0)
#define _0s ((const)__pcc_in->data.leaf.capt0.range.start)
#define _0e ((const)__pcc_in->data.leaf.capt0.range.end)
    __ = mstro_stp_val_alloc(MSTRO_STP_POINTER);   DEBUG("found pointer\n"); 
#undef _0e
#undef _0s
#undef _0
#undef __
#undef auxil
}

static void pcc_action_user_type_name_0(mstro_stp_context_t *__pcc_ctx, pcc_thunk_t *__pcc_in, pcc_value_t *__pcc_out) {
#define auxil (__pcc_ctx->auxil)
#define __ (*__pcc_out)
#define ide (*__pcc_in->data.leaf.values.buf[0])
#define _0 pcc_get_capture_string(__pcc_ctx, &__pcc_in->data.leaf.capt0)
#define _0s ((const)__pcc_in->data.leaf.capt0.range.start)
#define _0e ((const)__pcc_in->data.leaf.capt0.range.end)
    __ = ide; DEBUG("User-defined type name %s\n", ide); 
#undef _0e
#undef _0s
#undef _0
#undef ide
#undef __
#undef auxil
}

static void pcc_action_type_arguments_0(mstro_stp_context_t *__pcc_ctx, pcc_thunk_t *__pcc_in, pcc_value_t *__pcc_out) {
#define auxil (__pcc_ctx->auxil)
#define __ (*__pcc_out)
#define a (*__pcc_in->data.leaf.values.buf[0])
#define l (*__pcc_in->data.leaf.values.buf[1])
#define _0 pcc_get_capture_string(__pcc_ctx, &__pcc_in->data.leaf.capt0)
#define _0s ((const)__pcc_in->data.leaf.capt0.range.start)
#define _0e ((const)__pcc_in->data.leaf.capt0.range.end)
    DEBUG("unnamed and keyword type arguments\n");
    size_t l_a,l_l, l_tot;
    struct mstro_stp_val *tmp;
    LL_COUNT2(a,tmp,l_a,list_tail);
    LL_COUNT2(l,tmp,l_l,list_tail);

    assert(a->kind == MSTRO_STP_LIST);
    assert(l->kind == MSTRO_STP_LIST);
    __=a;
    LL_CONCAT2(__,l,list_tail);

    LL_COUNT2(__,tmp,l_tot,list_tail);
    DEBUG("unnamed count %zu, named count %zu, total %zu\n", l_a, l_l, l_tot);

#undef _0e
#undef _0s
#undef _0
#undef l
#undef a
#undef __
#undef auxil
}

static void pcc_action_type_arguments_1(mstro_stp_context_t *__pcc_ctx, pcc_thunk_t *__pcc_in, pcc_value_t *__pcc_out) {
#define auxil (__pcc_ctx->auxil)
#define __ (*__pcc_out)
#define a (*__pcc_in->data.leaf.values.buf[0])
#define _0 pcc_get_capture_string(__pcc_ctx, &__pcc_in->data.leaf.capt0)
#define _0s ((const)__pcc_in->data.leaf.capt0.range.start)
#define _0e ((const)__pcc_in->data.leaf.capt0.range.end)
    __=a;
    DEBUG("only unnamed type arguments\n");
#undef _0e
#undef _0s
#undef _0
#undef a
#undef __
#undef auxil
}

static void pcc_action_type_arguments_2(mstro_stp_context_t *__pcc_ctx, pcc_thunk_t *__pcc_in, pcc_value_t *__pcc_out) {
#define auxil (__pcc_ctx->auxil)
#define __ (*__pcc_out)
#define l (*__pcc_in->data.leaf.values.buf[1])
#define _0 pcc_get_capture_string(__pcc_ctx, &__pcc_in->data.leaf.capt0)
#define _0s ((const)__pcc_in->data.leaf.capt0.range.start)
#define _0e ((const)__pcc_in->data.leaf.capt0.range.end)
    __=l;
    DEBUG("only keyword-style type arguments\n");
#undef _0e
#undef _0s
#undef _0
#undef l
#undef __
#undef auxil
}

static void pcc_action_type_arguments_3(mstro_stp_context_t *__pcc_ctx, pcc_thunk_t *__pcc_in, pcc_value_t *__pcc_out) {
#define auxil (__pcc_ctx->auxil)
#define __ (*__pcc_out)
#define _0 pcc_get_capture_string(__pcc_ctx, &__pcc_in->data.leaf.capt0)
#define _0s ((const)__pcc_in->data.leaf.capt0.range.start)
#define _0e ((const)__pcc_in->data.leaf.capt0.range.end)
    __=NULL;
    DEBUG("empty restrictions list\n");
#undef _0e
#undef _0s
#undef _0
#undef __
#undef auxil
}

static void pcc_action_type_restriction_list_0(mstro_stp_context_t *__pcc_ctx, pcc_thunk_t *__pcc_in, pcc_value_t *__pcc_out) {
#define auxil (__pcc_ctx->auxil)
#define __ (*__pcc_out)
#define r (*__pcc_in->data.leaf.values.buf[0])
#define l (*__pcc_in->data.leaf.values.buf[1])
#define _0 pcc_get_capture_string(__pcc_ctx, &__pcc_in->data.leaf.capt0)
#define _0s ((const)__pcc_in->data.leaf.capt0.range.start)
#define _0e ((const)__pcc_in->data.leaf.capt0.range.end)
    DEBUG("one more entry in type restriction list\n");
    __=mstro_stp_val__cons(r,l);
    if(__==NULL) {
      ERR("Failed to allocate type restriction list\n");
      auxil->got_error=true;
    }
#undef _0e
#undef _0s
#undef _0
#undef l
#undef r
#undef __
#undef auxil
}

static void pcc_action_type_restriction_list_1(mstro_stp_context_t *__pcc_ctx, pcc_thunk_t *__pcc_in, pcc_value_t *__pcc_out) {
#define auxil (__pcc_ctx->auxil)
#define __ (*__pcc_out)
#define r (*__pcc_in->data.leaf.values.buf[0])
#define _0 pcc_get_capture_string(__pcc_ctx, &__pcc_in->data.leaf.capt0)
#define _0s ((const)__pcc_in->data.leaf.capt0.range.start)
#define _0e ((const)__pcc_in->data.leaf.capt0.range.end)
    DEBUG("tail of type restriction list\n");
    __=mstro_stp_val__cons(r,NULL);
    if(__==NULL) {
      ERR("Failed to allocate type restriction list\n");
      auxil->got_error=true;
    }
#undef _0e
#undef _0s
#undef _0
#undef r
#undef __
#undef auxil
}

static void pcc_action_type_restriction_0(mstro_stp_context_t *__pcc_ctx, pcc_thunk_t *__pcc_in, pcc_value_t *__pcc_out) {
#define auxil (__pcc_ctx->auxil)
#define __ (*__pcc_out)
#define x (*__pcc_in->data.leaf.values.buf[0])
#define _0 pcc_get_capture_string(__pcc_ctx, &__pcc_in->data.leaf.capt0)
#define _0s ((const)__pcc_in->data.leaf.capt0.range.start)
#define _0e ((const)__pcc_in->data.leaf.capt0.range.end)
    switch(x->kind) {
    case MSTRO_STP_INTVAL: {
      int64_t v = x->intval;
      x->kind = MSTRO_STP_MININT;
      x->minintval = v;
      break;
      }
    case MSTRO_STP_UINTVAL: {
      uint64_t v = x->uintval;
      x->kind = MSTRO_STP_MINUINT;
      x->minuintval = v;
      break;
      }
    case MSTRO_STP_FLOATVAL: {
      float v = x->floatval;
      x->kind = MSTRO_STP_MINFLOAT;
      x->minfloatval = v;
      break;
      }
    case MSTRO_STP_DOUBLEVAL: {
      double v =x->doubleval;
      x->kind = MSTRO_STP_MINDOUBLE;
      x->mindoubleval = v;
      break;
      }
    default:
      ERR("Invalid data type for min constraint\n");
      x->kind = MSTRO_STP_ERROR;
      x->errmsg = strdup("Invalid data type for min constraint\n");
      auxil->got_error=true;
    }
    __ = x;
#undef _0e
#undef _0s
#undef _0
#undef x
#undef __
#undef auxil
}

static void pcc_action_type_restriction_1(mstro_stp_context_t *__pcc_ctx, pcc_thunk_t *__pcc_in, pcc_value_t *__pcc_out) {
#define auxil (__pcc_ctx->auxil)
#define __ (*__pcc_out)
#define x (*__pcc_in->data.leaf.values.buf[0])
#define _0 pcc_get_capture_string(__pcc_ctx, &__pcc_in->data.leaf.capt0)
#define _0s ((const)__pcc_in->data.leaf.capt0.range.start)
#define _0e ((const)__pcc_in->data.leaf.capt0.range.end)
    switch(x->kind) {
    case MSTRO_STP_INTVAL: {
      int64_t v = x->intval;
      x->kind = MSTRO_STP_MAXINT;
      x->maxintval = v;
      break;
      }
    case MSTRO_STP_UINTVAL: {
      uint64_t v = x->uintval;
      x->kind = MSTRO_STP_MAXUINT;
      x->maxuintval = v;
      break;
      }
    case MSTRO_STP_FLOATVAL: {
      float v = x->floatval;
      x->kind = MSTRO_STP_MAXFLOAT;
      x->maxfloatval = v;
      break;
      }
    case MSTRO_STP_DOUBLEVAL: {
      double v =x->doubleval;
      x->kind = MSTRO_STP_MAXDOUBLE;
      x->maxdoubleval = v;
      break;
      }
    default:
      ERR("Invalid data type for max constraint\n");
      x->kind = MSTRO_STP_ERROR;
      x->errmsg = strdup("Invalid data type for max constraint\n");
      auxil->got_error=true;
    }
    __ = x;
#undef _0e
#undef _0s
#undef _0
#undef x
#undef __
#undef auxil
}

static void pcc_action_type_restriction_2(mstro_stp_context_t *__pcc_ctx, pcc_thunk_t *__pcc_in, pcc_value_t *__pcc_out) {
#define auxil (__pcc_ctx->auxil)
#define __ (*__pcc_out)
#define s (*__pcc_in->data.leaf.values.buf[1])
#define _0 pcc_get_capture_string(__pcc_ctx, &__pcc_in->data.leaf.capt0)
#define _0s ((const)__pcc_in->data.leaf.capt0.range.start)
#define _0e ((const)__pcc_in->data.leaf.capt0.range.end)
    DEBUG("found exclude string |%s|\n", s->strval);
    char *tmp = s->strval;
    s->kind = MSTRO_STP_EXCLSTR;
    s->exclstrval = tmp;
    __ = s;
#undef _0e
#undef _0s
#undef _0
#undef s
#undef __
#undef auxil
}

static void pcc_action_type_restriction_3(mstro_stp_context_t *__pcc_ctx, pcc_thunk_t *__pcc_in, pcc_value_t *__pcc_out) {
#define auxil (__pcc_ctx->auxil)
#define __ (*__pcc_out)
#define v (*__pcc_in->data.leaf.values.buf[2])
#define _0 pcc_get_capture_string(__pcc_ctx, &__pcc_in->data.leaf.capt0)
#define _0s ((const)__pcc_in->data.leaf.capt0.range.start)
#define _0e ((const)__pcc_in->data.leaf.capt0.range.end)
    DEBUG("found ignore-case with value %d\n", v->boolval);
    bool tmp = v->boolval;
    v->kind = MSTRO_STP_ICASE;
    v->icase = tmp;
    __ = v;
#undef _0e
#undef _0s
#undef _0
#undef v
#undef __
#undef auxil
}

static void pcc_action_type_restriction_4(mstro_stp_context_t *__pcc_ctx, pcc_thunk_t *__pcc_in, pcc_value_t *__pcc_out) {
#define auxil (__pcc_ctx->auxil)
#define __ (*__pcc_out)
#define s (*__pcc_in->data.leaf.values.buf[1])
#define _0 pcc_get_capture_string(__pcc_ctx, &__pcc_in->data.leaf.capt0)
#define _0s ((const)__pcc_in->data.leaf.capt0.range.start)
#define _0e ((const)__pcc_in->data.leaf.capt0.range.end)
    DEBUG("found name key with value |%s|\n", s->strval);
    char *tmp = s->strval;
    s->kind = MSTRO_STP_NAME;
    s->nameval = tmp;
    __ = s;
#undef _0e
#undef _0s
#undef _0
#undef s
#undef __
#undef auxil
}

static void pcc_action_unnamed_args_0(mstro_stp_context_t *__pcc_ctx, pcc_thunk_t *__pcc_in, pcc_value_t *__pcc_out) {
#define auxil (__pcc_ctx->auxil)
#define __ (*__pcc_out)
#define r (*__pcc_in->data.leaf.values.buf[0])
#define tail (*__pcc_in->data.leaf.values.buf[1])
#define _0 pcc_get_capture_string(__pcc_ctx, &__pcc_in->data.leaf.capt0)
#define _0s ((const)__pcc_in->data.leaf.capt0.range.start)
#define _0e ((const)__pcc_in->data.leaf.capt0.range.end)
    __=mstro_stp_val__cons(r,tail);
    if(__==NULL) {
      ERR("Failed to allocate unnamed args list entry\n");
      auxil->got_error=true;
    }
#undef _0e
#undef _0s
#undef _0
#undef tail
#undef r
#undef __
#undef auxil
}

static void pcc_action_unnamed_args_1(mstro_stp_context_t *__pcc_ctx, pcc_thunk_t *__pcc_in, pcc_value_t *__pcc_out) {
#define auxil (__pcc_ctx->auxil)
#define __ (*__pcc_out)
#define s (*__pcc_in->data.leaf.values.buf[2])
#define tail (*__pcc_in->data.leaf.values.buf[1])
#define _0 pcc_get_capture_string(__pcc_ctx, &__pcc_in->data.leaf.capt0)
#define _0s ((const)__pcc_in->data.leaf.capt0.range.start)
#define _0e ((const)__pcc_in->data.leaf.capt0.range.end)
    __=mstro_stp_val__cons(s,tail);
    if(__==NULL) {
      ERR("Failed to allocate unnamed args list entry\n");
      auxil->got_error=true;
    }
#undef _0e
#undef _0s
#undef _0
#undef tail
#undef s
#undef __
#undef auxil
}

static void pcc_action_unnamed_args_2(mstro_stp_context_t *__pcc_ctx, pcc_thunk_t *__pcc_in, pcc_value_t *__pcc_out) {
#define auxil (__pcc_ctx->auxil)
#define __ (*__pcc_out)
#define t (*__pcc_in->data.leaf.values.buf[3])
#define _0 pcc_get_capture_string(__pcc_ctx, &__pcc_in->data.leaf.capt0)
#define _0s ((const)__pcc_in->data.leaf.capt0.range.start)
#define _0e ((const)__pcc_in->data.leaf.capt0.range.end)
    __=mstro_stp_val__cons(t, NULL); 
#undef _0e
#undef _0s
#undef _0
#undef t
#undef __
#undef auxil
}

static void pcc_action_unnamed_args_3(mstro_stp_context_t *__pcc_ctx, pcc_thunk_t *__pcc_in, pcc_value_t *__pcc_out) {
#define auxil (__pcc_ctx->auxil)
#define __ (*__pcc_out)
#define s (*__pcc_in->data.leaf.values.buf[2])
#define _0 pcc_get_capture_string(__pcc_ctx, &__pcc_in->data.leaf.capt0)
#define _0s ((const)__pcc_in->data.leaf.capt0.range.start)
#define _0e ((const)__pcc_in->data.leaf.capt0.range.end)
    __=mstro_stp_val__cons(s, NULL); 
#undef _0e
#undef _0s
#undef _0
#undef s
#undef __
#undef auxil
}

static void pcc_action_identifier_0(mstro_stp_context_t *__pcc_ctx, pcc_thunk_t *__pcc_in, pcc_value_t *__pcc_out) {
#define auxil (__pcc_ctx->auxil)
#define __ (*__pcc_out)
#define _0 pcc_get_capture_string(__pcc_ctx, &__pcc_in->data.leaf.capt0)
#define _0s ((const)__pcc_in->data.leaf.capt0.range.start)
#define _0e ((const)__pcc_in->data.leaf.capt0.range.end)
#define _1 pcc_get_capture_string(__pcc_ctx, __pcc_in->data.leaf.capts.buf[0])
#define _1s __pcc_in->data.leaf.capts.buf[0]->range.start
#define _1e __pcc_in->data.leaf.capts.buf[0]->range.end
    __=mstro_stp_val_alloc(MSTRO_STP_STRVAL);
    __->strval = strdup(_1);
    if(__->strval==NULL) {
      ERR("Failed to allocate string for identifier %s\n", _1);
      auxil->got_error = true;
    }
#undef _1e
#undef _1s
#undef _1
#undef _0e
#undef _0s
#undef _0
#undef __
#undef auxil
}

static void pcc_action_string_0(mstro_stp_context_t *__pcc_ctx, pcc_thunk_t *__pcc_in, pcc_value_t *__pcc_out) {
#define auxil (__pcc_ctx->auxil)
#define __ (*__pcc_out)
#define _0 pcc_get_capture_string(__pcc_ctx, &__pcc_in->data.leaf.capt0)
#define _0s ((const)__pcc_in->data.leaf.capt0.range.start)
#define _0e ((const)__pcc_in->data.leaf.capt0.range.end)
#define _1 pcc_get_capture_string(__pcc_ctx, __pcc_in->data.leaf.capts.buf[0])
#define _1s __pcc_in->data.leaf.capts.buf[0]->range.start
#define _1e __pcc_in->data.leaf.capts.buf[0]->range.end
    __=mstro_stp_val_alloc(MSTRO_STP_STRVAL); 
    __->strval = strdup(_1);
    if(__->strval==NULL) {
      ERR("Failed to allocate string for \"%s\"\n", _1);
      auxil->got_error = true;
    }
#undef _1e
#undef _1s
#undef _1
#undef _0e
#undef _0s
#undef _0
#undef __
#undef auxil
}

static void pcc_action_string_1(mstro_stp_context_t *__pcc_ctx, pcc_thunk_t *__pcc_in, pcc_value_t *__pcc_out) {
#define auxil (__pcc_ctx->auxil)
#define __ (*__pcc_out)
#define _0 pcc_get_capture_string(__pcc_ctx, &__pcc_in->data.leaf.capt0)
#define _0s ((const)__pcc_in->data.leaf.capt0.range.start)
#define _0e ((const)__pcc_in->data.leaf.capt0.range.end)
#define _2 pcc_get_capture_string(__pcc_ctx, __pcc_in->data.leaf.capts.buf[1])
#define _2s __pcc_in->data.leaf.capts.buf[1]->range.start
#define _2e __pcc_in->data.leaf.capts.buf[1]->range.end
    __=mstro_stp_val_alloc(MSTRO_STP_STRVAL);
    __->strval = strdup(_2);
    if(__->strval==NULL) {
      ERR("Failed to allocate string for '%s'\n", _2);
      auxil->got_error = true;
    }
#undef _2e
#undef _2s
#undef _2
#undef _0e
#undef _0s
#undef _0
#undef __
#undef auxil
}

static void pcc_action_bool_0(mstro_stp_context_t *__pcc_ctx, pcc_thunk_t *__pcc_in, pcc_value_t *__pcc_out) {
#define auxil (__pcc_ctx->auxil)
#define __ (*__pcc_out)
#define _0 pcc_get_capture_string(__pcc_ctx, &__pcc_in->data.leaf.capt0)
#define _0s ((const)__pcc_in->data.leaf.capt0.range.start)
#define _0e ((const)__pcc_in->data.leaf.capt0.range.end)
    __=mstro_stp_val_alloc(MSTRO_STP_BOOLVAL); __->boolval = true; 
#undef _0e
#undef _0s
#undef _0
#undef __
#undef auxil
}

static void pcc_action_bool_1(mstro_stp_context_t *__pcc_ctx, pcc_thunk_t *__pcc_in, pcc_value_t *__pcc_out) {
#define auxil (__pcc_ctx->auxil)
#define __ (*__pcc_out)
#define _0 pcc_get_capture_string(__pcc_ctx, &__pcc_in->data.leaf.capt0)
#define _0s ((const)__pcc_in->data.leaf.capt0.range.start)
#define _0e ((const)__pcc_in->data.leaf.capt0.range.end)
    __=mstro_stp_val_alloc(MSTRO_STP_BOOLVAL); __->boolval = false; 
#undef _0e
#undef _0s
#undef _0
#undef __
#undef auxil
}

static void pcc_action_bool_2(mstro_stp_context_t *__pcc_ctx, pcc_thunk_t *__pcc_in, pcc_value_t *__pcc_out) {
#define auxil (__pcc_ctx->auxil)
#define __ (*__pcc_out)
#define _0 pcc_get_capture_string(__pcc_ctx, &__pcc_in->data.leaf.capt0)
#define _0s ((const)__pcc_in->data.leaf.capt0.range.start)
#define _0e ((const)__pcc_in->data.leaf.capt0.range.end)
    __=mstro_stp_val_alloc(MSTRO_STP_BOOLVAL); __->boolval = false; 
#undef _0e
#undef _0s
#undef _0
#undef __
#undef auxil
}

static void pcc_action_bool_3(mstro_stp_context_t *__pcc_ctx, pcc_thunk_t *__pcc_in, pcc_value_t *__pcc_out) {
#define auxil (__pcc_ctx->auxil)
#define __ (*__pcc_out)
#define _0 pcc_get_capture_string(__pcc_ctx, &__pcc_in->data.leaf.capt0)
#define _0s ((const)__pcc_in->data.leaf.capt0.range.start)
#define _0e ((const)__pcc_in->data.leaf.capt0.range.end)
    __=mstro_stp_val_alloc(MSTRO_STP_BOOLVAL); __->boolval = true; 
#undef _0e
#undef _0s
#undef _0
#undef __
#undef auxil
}

static void pcc_action_space_0(mstro_stp_context_t *__pcc_ctx, pcc_thunk_t *__pcc_in, pcc_value_t *__pcc_out) {
#define auxil (__pcc_ctx->auxil)
#define __ (*__pcc_out)
#define _0 pcc_get_capture_string(__pcc_ctx, &__pcc_in->data.leaf.capt0)
#define _0s ((const)__pcc_in->data.leaf.capt0.range.start)
#define _0e ((const)__pcc_in->data.leaf.capt0.range.end)
    ; 
#undef _0e
#undef _0s
#undef _0
#undef __
#undef auxil
}

static void pcc_action_number_0(mstro_stp_context_t *__pcc_ctx, pcc_thunk_t *__pcc_in, pcc_value_t *__pcc_out) {
#define auxil (__pcc_ctx->auxil)
#define __ (*__pcc_out)
#define x (*__pcc_in->data.leaf.values.buf[0])
#define _0 pcc_get_capture_string(__pcc_ctx, &__pcc_in->data.leaf.capt0)
#define _0s ((const)__pcc_in->data.leaf.capt0.range.start)
#define _0e ((const)__pcc_in->data.leaf.capt0.range.end)
    __ = x; 
#undef _0e
#undef _0s
#undef _0
#undef x
#undef __
#undef auxil
}

static void pcc_action_number_1(mstro_stp_context_t *__pcc_ctx, pcc_thunk_t *__pcc_in, pcc_value_t *__pcc_out) {
#define auxil (__pcc_ctx->auxil)
#define __ (*__pcc_out)
#define x (*__pcc_in->data.leaf.values.buf[0])
#define _0 pcc_get_capture_string(__pcc_ctx, &__pcc_in->data.leaf.capt0)
#define _0s ((const)__pcc_in->data.leaf.capt0.range.start)
#define _0e ((const)__pcc_in->data.leaf.capt0.range.end)
    __ = x; 
#undef _0e
#undef _0s
#undef _0
#undef x
#undef __
#undef auxil
}

static void pcc_action_signed_number_0(mstro_stp_context_t *__pcc_ctx, pcc_thunk_t *__pcc_in, pcc_value_t *__pcc_out) {
#define auxil (__pcc_ctx->auxil)
#define __ (*__pcc_out)
#define x (*__pcc_in->data.leaf.values.buf[0])
#define _0 pcc_get_capture_string(__pcc_ctx, &__pcc_in->data.leaf.capt0)
#define _0s ((const)__pcc_in->data.leaf.capt0.range.start)
#define _0e ((const)__pcc_in->data.leaf.capt0.range.end)
    /* flip sign */
    if(x->uintval>INT64_MAX) {
      ERR("integral value %" PRIu64 " too big for int64 type\n", __->uintval);
      auxil->got_error = true;
    }
    __ = x;
    int64_t tmp = x->uintval;
    __->kind = MSTRO_STP_INTVAL;
    __->intval = -tmp;
#undef _0e
#undef _0s
#undef _0
#undef x
#undef __
#undef auxil
}

static void pcc_action_signed_number_1(mstro_stp_context_t *__pcc_ctx, pcc_thunk_t *__pcc_in, pcc_value_t *__pcc_out) {
#define auxil (__pcc_ctx->auxil)
#define __ (*__pcc_out)
#define x (*__pcc_in->data.leaf.values.buf[0])
#define _0 pcc_get_capture_string(__pcc_ctx, &__pcc_in->data.leaf.capt0)
#define _0s ((const)__pcc_in->data.leaf.capt0.range.start)
#define _0e ((const)__pcc_in->data.leaf.capt0.range.end)
    __ = x; __->doubleval *=-1; 
#undef _0e
#undef _0s
#undef _0
#undef x
#undef __
#undef auxil
}

static void pcc_action_unsigned_number_0(mstro_stp_context_t *__pcc_ctx, pcc_thunk_t *__pcc_in, pcc_value_t *__pcc_out) {
#define auxil (__pcc_ctx->auxil)
#define __ (*__pcc_out)
#define x (*__pcc_in->data.leaf.values.buf[0])
#define _0 pcc_get_capture_string(__pcc_ctx, &__pcc_in->data.leaf.capt0)
#define _0s ((const)__pcc_in->data.leaf.capt0.range.start)
#define _0e ((const)__pcc_in->data.leaf.capt0.range.end)
    __ = x; 
#undef _0e
#undef _0s
#undef _0
#undef x
#undef __
#undef auxil
}

static void pcc_action_unsigned_number_1(mstro_stp_context_t *__pcc_ctx, pcc_thunk_t *__pcc_in, pcc_value_t *__pcc_out) {
#define auxil (__pcc_ctx->auxil)
#define __ (*__pcc_out)
#define x (*__pcc_in->data.leaf.values.buf[0])
#define _0 pcc_get_capture_string(__pcc_ctx, &__pcc_in->data.leaf.capt0)
#define _0s ((const)__pcc_in->data.leaf.capt0.range.start)
#define _0e ((const)__pcc_in->data.leaf.capt0.range.end)
    __ = x; 
#undef _0e
#undef _0s
#undef _0
#undef x
#undef __
#undef auxil
}

static void pcc_action_integer_0(mstro_stp_context_t *__pcc_ctx, pcc_thunk_t *__pcc_in, pcc_value_t *__pcc_out) {
#define auxil (__pcc_ctx->auxil)
#define __ (*__pcc_out)
#define _0 pcc_get_capture_string(__pcc_ctx, &__pcc_in->data.leaf.capt0)
#define _0s ((const)__pcc_in->data.leaf.capt0.range.start)
#define _0e ((const)__pcc_in->data.leaf.capt0.range.end)
#define _1 pcc_get_capture_string(__pcc_ctx, __pcc_in->data.leaf.capts.buf[0])
#define _1s __pcc_in->data.leaf.capts.buf[0]->range.start
#define _1e __pcc_in->data.leaf.capts.buf[0]->range.end
    /* parse as uint64 */
    __ = mstro_stp_val_alloc(MSTRO_STP_UINTVAL);
    char *endptr;
    __->uintval = strtoumax(_1,&endptr,10);
#undef _1e
#undef _1s
#undef _1
#undef _0e
#undef _0s
#undef _0
#undef __
#undef auxil
}

static void pcc_action_decimal_0(mstro_stp_context_t *__pcc_ctx, pcc_thunk_t *__pcc_in, pcc_value_t *__pcc_out) {
#define auxil (__pcc_ctx->auxil)
#define __ (*__pcc_out)
#define _0 pcc_get_capture_string(__pcc_ctx, &__pcc_in->data.leaf.capt0)
#define _0s ((const)__pcc_in->data.leaf.capt0.range.start)
#define _0e ((const)__pcc_in->data.leaf.capt0.range.end)
#define _1 pcc_get_capture_string(__pcc_ctx, __pcc_in->data.leaf.capts.buf[0])
#define _1s __pcc_in->data.leaf.capts.buf[0]->range.start
#define _1e __pcc_in->data.leaf.capts.buf[0]->range.end
    /* parse as double */
    __ = mstro_stp_val_alloc(MSTRO_STP_DOUBLEVAL);
    char *endptr;
    __->doubleval = atof(_1);
#undef _1e
#undef _1s
#undef _1
#undef _0e
#undef _0s
#undef _0
#undef __
#undef auxil
}

static pcc_thunk_chunk_t *pcc_evaluate_rule_type_expression(mstro_stp_context_t *ctx);
static pcc_thunk_chunk_t *pcc_evaluate_rule_restricted_type(mstro_stp_context_t *ctx);
static pcc_thunk_chunk_t *pcc_evaluate_rule_type_name(mstro_stp_context_t *ctx);
static pcc_thunk_chunk_t *pcc_evaluate_rule_builtin_type_name(mstro_stp_context_t *ctx);
static pcc_thunk_chunk_t *pcc_evaluate_rule_user_type_name(mstro_stp_context_t *ctx);
static pcc_thunk_chunk_t *pcc_evaluate_rule_type_arguments(mstro_stp_context_t *ctx);
static pcc_thunk_chunk_t *pcc_evaluate_rule_type_restriction_list(mstro_stp_context_t *ctx);
static pcc_thunk_chunk_t *pcc_evaluate_rule_type_restriction(mstro_stp_context_t *ctx);
static pcc_thunk_chunk_t *pcc_evaluate_rule_unnamed_args(mstro_stp_context_t *ctx);
static pcc_thunk_chunk_t *pcc_evaluate_rule_identifier(mstro_stp_context_t *ctx);
static pcc_thunk_chunk_t *pcc_evaluate_rule_string(mstro_stp_context_t *ctx);
static pcc_thunk_chunk_t *pcc_evaluate_rule_bool(mstro_stp_context_t *ctx);
static pcc_thunk_chunk_t *pcc_evaluate_rule_space(mstro_stp_context_t *ctx);
static pcc_thunk_chunk_t *pcc_evaluate_rule_number(mstro_stp_context_t *ctx);
static pcc_thunk_chunk_t *pcc_evaluate_rule_signed_number(mstro_stp_context_t *ctx);
static pcc_thunk_chunk_t *pcc_evaluate_rule_unsigned_number(mstro_stp_context_t *ctx);
static pcc_thunk_chunk_t *pcc_evaluate_rule_integer(mstro_stp_context_t *ctx);
static pcc_thunk_chunk_t *pcc_evaluate_rule_decimal(mstro_stp_context_t *ctx);
static pcc_thunk_chunk_t *pcc_evaluate_rule_EOF(mstro_stp_context_t *ctx);

static pcc_thunk_chunk_t *pcc_evaluate_rule_type_expression(mstro_stp_context_t *ctx) {
    pcc_thunk_chunk_t *const chunk = pcc_thunk_chunk__create(ctx->auxil);
    chunk->pos = ctx->pos;
    pcc_value_table__resize(ctx->auxil, &chunk->values, 1);
    pcc_capture_table__resize(ctx->auxil, &chunk->capts, 0);
    {
        int i;
        for (i = 0;; i++) {
            if (!pcc_apply_rule(ctx, pcc_evaluate_rule_space, &chunk->thunks, NULL)) goto L0001;
        }
    L0001:;
    }
    if (!pcc_apply_rule(ctx, pcc_evaluate_rule_restricted_type, &chunk->thunks, &(chunk->values.buf[0]))) goto L0000;
    {
        int i;
        for (i = 0;; i++) {
            if (!pcc_apply_rule(ctx, pcc_evaluate_rule_space, &chunk->thunks, NULL)) goto L0002;
        }
    L0002:;
    }
    if (!pcc_apply_rule(ctx, pcc_evaluate_rule_EOF, &chunk->thunks, NULL)) goto L0000;
    {
        pcc_thunk_t *const thunk = pcc_thunk__create_leaf(ctx->auxil, pcc_action_type_expression_0, 1, 0);
        thunk->data.leaf.values.buf[0] = &(chunk->values.buf[0]);
        thunk->data.leaf.capt0.range.start = chunk->pos;
        thunk->data.leaf.capt0.range.end = ctx->pos;
        pcc_thunk_array__add(ctx->auxil, &chunk->thunks, thunk);
    }
    return chunk;
L0000:;
    pcc_thunk_chunk__destroy(ctx->auxil, chunk);
    return NULL;
}

static pcc_thunk_chunk_t *pcc_evaluate_rule_restricted_type(mstro_stp_context_t *ctx) {
    pcc_thunk_chunk_t *const chunk = pcc_thunk_chunk__create(ctx->auxil);
    chunk->pos = ctx->pos;
    pcc_value_table__resize(ctx->auxil, &chunk->values, 2);
    pcc_capture_table__resize(ctx->auxil, &chunk->capts, 0);
    if (!pcc_apply_rule(ctx, pcc_evaluate_rule_type_name, &chunk->thunks, &(chunk->values.buf[0]))) goto L0000;
    {
        int i;
        for (i = 0;; i++) {
            if (!pcc_apply_rule(ctx, pcc_evaluate_rule_space, &chunk->thunks, NULL)) goto L0001;
        }
    L0001:;
    }
    if (!pcc_apply_rule(ctx, pcc_evaluate_rule_type_arguments, &chunk->thunks, &(chunk->values.buf[1]))) goto L0000;
    {
        pcc_thunk_t *const thunk = pcc_thunk__create_leaf(ctx->auxil, pcc_action_restricted_type_0, 2, 0);
        thunk->data.leaf.values.buf[0] = &(chunk->values.buf[0]);
        thunk->data.leaf.values.buf[1] = &(chunk->values.buf[1]);
        thunk->data.leaf.capt0.range.start = chunk->pos;
        thunk->data.leaf.capt0.range.end = ctx->pos;
        pcc_thunk_array__add(ctx->auxil, &chunk->thunks, thunk);
    }
    return chunk;
L0000:;
    pcc_thunk_chunk__destroy(ctx->auxil, chunk);
    return NULL;
}

static pcc_thunk_chunk_t *pcc_evaluate_rule_type_name(mstro_stp_context_t *ctx) {
    pcc_thunk_chunk_t *const chunk = pcc_thunk_chunk__create(ctx->auxil);
    chunk->pos = ctx->pos;
    pcc_value_table__resize(ctx->auxil, &chunk->values, 1);
    pcc_capture_table__resize(ctx->auxil, &chunk->capts, 0);
    {
        const int p = ctx->pos;
        const int n = chunk->thunks.len;
        if (!pcc_apply_rule(ctx, pcc_evaluate_rule_builtin_type_name, &chunk->thunks, &(chunk->values.buf[0]))) goto L0002;
        {
            pcc_thunk_t *const thunk = pcc_thunk__create_leaf(ctx->auxil, pcc_action_type_name_0, 1, 0);
            thunk->data.leaf.values.buf[0] = &(chunk->values.buf[0]);
            thunk->data.leaf.capt0.range.start = chunk->pos;
            thunk->data.leaf.capt0.range.end = ctx->pos;
            pcc_thunk_array__add(ctx->auxil, &chunk->thunks, thunk);
        }
        goto L0001;
    L0002:;
        ctx->pos = p;
        pcc_thunk_array__revert(ctx->auxil, &chunk->thunks, n);
        if (!pcc_apply_rule(ctx, pcc_evaluate_rule_user_type_name, &chunk->thunks, &(chunk->values.buf[0]))) goto L0003;
        {
            pcc_thunk_t *const thunk = pcc_thunk__create_leaf(ctx->auxil, pcc_action_type_name_1, 1, 0);
            thunk->data.leaf.values.buf[0] = &(chunk->values.buf[0]);
            thunk->data.leaf.capt0.range.start = chunk->pos;
            thunk->data.leaf.capt0.range.end = ctx->pos;
            pcc_thunk_array__add(ctx->auxil, &chunk->thunks, thunk);
        }
        goto L0001;
    L0003:;
        ctx->pos = p;
        pcc_thunk_array__revert(ctx->auxil, &chunk->thunks, n);
        goto L0000;
    L0001:;
    }
    return chunk;
L0000:;
    pcc_thunk_chunk__destroy(ctx->auxil, chunk);
    return NULL;
}

static pcc_thunk_chunk_t *pcc_evaluate_rule_builtin_type_name(mstro_stp_context_t *ctx) {
    pcc_thunk_chunk_t *const chunk = pcc_thunk_chunk__create(ctx->auxil);
    chunk->pos = ctx->pos;
    pcc_value_table__resize(ctx->auxil, &chunk->values, 0);
    pcc_capture_table__resize(ctx->auxil, &chunk->capts, 0);
    {
        const int p = ctx->pos;
        const int n = chunk->thunks.len;
        {
            if (
                pcc_refill_buffer(ctx, 4) < 4 ||
                (ctx->buffer.buf + ctx->pos)[0] != 'b' ||
                (ctx->buffer.buf + ctx->pos)[1] != 'o' ||
                (ctx->buffer.buf + ctx->pos)[2] != 'o' ||
                (ctx->buffer.buf + ctx->pos)[3] != 'l'
            ) goto L0002;
            ctx->pos += 4;
        }
        {
            pcc_thunk_t *const thunk = pcc_thunk__create_leaf(ctx->auxil, pcc_action_builtin_type_name_0, 0, 0);
            thunk->data.leaf.capt0.range.start = chunk->pos;
            thunk->data.leaf.capt0.range.end = ctx->pos;
            pcc_thunk_array__add(ctx->auxil, &chunk->thunks, thunk);
        }
        goto L0001;
    L0002:;
        ctx->pos = p;
        pcc_thunk_array__revert(ctx->auxil, &chunk->thunks, n);
        {
            if (
                pcc_refill_buffer(ctx, 4) < 4 ||
                (ctx->buffer.buf + ctx->pos)[0] != 'u' ||
                (ctx->buffer.buf + ctx->pos)[1] != 'i' ||
                (ctx->buffer.buf + ctx->pos)[2] != 'n' ||
                (ctx->buffer.buf + ctx->pos)[3] != 't'
            ) goto L0003;
            ctx->pos += 4;
        }
        {
            pcc_thunk_t *const thunk = pcc_thunk__create_leaf(ctx->auxil, pcc_action_builtin_type_name_1, 0, 0);
            thunk->data.leaf.capt0.range.start = chunk->pos;
            thunk->data.leaf.capt0.range.end = ctx->pos;
            pcc_thunk_array__add(ctx->auxil, &chunk->thunks, thunk);
        }
        goto L0001;
    L0003:;
        ctx->pos = p;
        pcc_thunk_array__revert(ctx->auxil, &chunk->thunks, n);
        {
            if (
                pcc_refill_buffer(ctx, 3) < 3 ||
                (ctx->buffer.buf + ctx->pos)[0] != 'i' ||
                (ctx->buffer.buf + ctx->pos)[1] != 'n' ||
                (ctx->buffer.buf + ctx->pos)[2] != 't'
            ) goto L0004;
            ctx->pos += 3;
        }
        {
            pcc_thunk_t *const thunk = pcc_thunk__create_leaf(ctx->auxil, pcc_action_builtin_type_name_2, 0, 0);
            thunk->data.leaf.capt0.range.start = chunk->pos;
            thunk->data.leaf.capt0.range.end = ctx->pos;
            pcc_thunk_array__add(ctx->auxil, &chunk->thunks, thunk);
        }
        goto L0001;
    L0004:;
        ctx->pos = p;
        pcc_thunk_array__revert(ctx->auxil, &chunk->thunks, n);
        {
            if (
                pcc_refill_buffer(ctx, 5) < 5 ||
                (ctx->buffer.buf + ctx->pos)[0] != 'f' ||
                (ctx->buffer.buf + ctx->pos)[1] != 'l' ||
                (ctx->buffer.buf + ctx->pos)[2] != 'o' ||
                (ctx->buffer.buf + ctx->pos)[3] != 'a' ||
                (ctx->buffer.buf + ctx->pos)[4] != 't'
            ) goto L0005;
            ctx->pos += 5;
        }
        {
            pcc_thunk_t *const thunk = pcc_thunk__create_leaf(ctx->auxil, pcc_action_builtin_type_name_3, 0, 0);
            thunk->data.leaf.capt0.range.start = chunk->pos;
            thunk->data.leaf.capt0.range.end = ctx->pos;
            pcc_thunk_array__add(ctx->auxil, &chunk->thunks, thunk);
        }
        goto L0001;
    L0005:;
        ctx->pos = p;
        pcc_thunk_array__revert(ctx->auxil, &chunk->thunks, n);
        {
            if (
                pcc_refill_buffer(ctx, 6) < 6 ||
                (ctx->buffer.buf + ctx->pos)[0] != 'd' ||
                (ctx->buffer.buf + ctx->pos)[1] != 'o' ||
                (ctx->buffer.buf + ctx->pos)[2] != 'u' ||
                (ctx->buffer.buf + ctx->pos)[3] != 'b' ||
                (ctx->buffer.buf + ctx->pos)[4] != 'l' ||
                (ctx->buffer.buf + ctx->pos)[5] != 'e'
            ) goto L0006;
            ctx->pos += 6;
        }
        {
            pcc_thunk_t *const thunk = pcc_thunk__create_leaf(ctx->auxil, pcc_action_builtin_type_name_4, 0, 0);
            thunk->data.leaf.capt0.range.start = chunk->pos;
            thunk->data.leaf.capt0.range.end = ctx->pos;
            pcc_thunk_array__add(ctx->auxil, &chunk->thunks, thunk);
        }
        goto L0001;
    L0006:;
        ctx->pos = p;
        pcc_thunk_array__revert(ctx->auxil, &chunk->thunks, n);
        {
            if (
                pcc_refill_buffer(ctx, 5) < 5 ||
                (ctx->buffer.buf + ctx->pos)[0] != 'r' ||
                (ctx->buffer.buf + ctx->pos)[1] != 'e' ||
                (ctx->buffer.buf + ctx->pos)[2] != 'g' ||
                (ctx->buffer.buf + ctx->pos)[3] != 'e' ||
                (ctx->buffer.buf + ctx->pos)[4] != 'x'
            ) goto L0007;
            ctx->pos += 5;
        }
        {
            pcc_thunk_t *const thunk = pcc_thunk__create_leaf(ctx->auxil, pcc_action_builtin_type_name_5, 0, 0);
            thunk->data.leaf.capt0.range.start = chunk->pos;
            thunk->data.leaf.capt0.range.end = ctx->pos;
            pcc_thunk_array__add(ctx->auxil, &chunk->thunks, thunk);
        }
        goto L0001;
    L0007:;
        ctx->pos = p;
        pcc_thunk_array__revert(ctx->auxil, &chunk->thunks, n);
        {
            if (
                pcc_refill_buffer(ctx, 3) < 3 ||
                (ctx->buffer.buf + ctx->pos)[0] != 's' ||
                (ctx->buffer.buf + ctx->pos)[1] != 't' ||
                (ctx->buffer.buf + ctx->pos)[2] != 'r'
            ) goto L0008;
            ctx->pos += 3;
        }
        {
            pcc_thunk_t *const thunk = pcc_thunk__create_leaf(ctx->auxil, pcc_action_builtin_type_name_6, 0, 0);
            thunk->data.leaf.capt0.range.start = chunk->pos;
            thunk->data.leaf.capt0.range.end = ctx->pos;
            pcc_thunk_array__add(ctx->auxil, &chunk->thunks, thunk);
        }
        goto L0001;
    L0008:;
        ctx->pos = p;
        pcc_thunk_array__revert(ctx->auxil, &chunk->thunks, n);
        {
            if (
                pcc_refill_buffer(ctx, 4) < 4 ||
                (ctx->buffer.buf + ctx->pos)[0] != 'b' ||
                (ctx->buffer.buf + ctx->pos)[1] != 'l' ||
                (ctx->buffer.buf + ctx->pos)[2] != 'o' ||
                (ctx->buffer.buf + ctx->pos)[3] != 'b'
            ) goto L0009;
            ctx->pos += 4;
        }
        {
            pcc_thunk_t *const thunk = pcc_thunk__create_leaf(ctx->auxil, pcc_action_builtin_type_name_7, 0, 0);
            thunk->data.leaf.capt0.range.start = chunk->pos;
            thunk->data.leaf.capt0.range.end = ctx->pos;
            pcc_thunk_array__add(ctx->auxil, &chunk->thunks, thunk);
        }
        goto L0001;
    L0009:;
        ctx->pos = p;
        pcc_thunk_array__revert(ctx->auxil, &chunk->thunks, n);
        {
            if (
                pcc_refill_buffer(ctx, 9) < 9 ||
                (ctx->buffer.buf + ctx->pos)[0] != 't' ||
                (ctx->buffer.buf + ctx->pos)[1] != 'i' ||
                (ctx->buffer.buf + ctx->pos)[2] != 'm' ||
                (ctx->buffer.buf + ctx->pos)[3] != 'e' ||
                (ctx->buffer.buf + ctx->pos)[4] != 's' ||
                (ctx->buffer.buf + ctx->pos)[5] != 't' ||
                (ctx->buffer.buf + ctx->pos)[6] != 'a' ||
                (ctx->buffer.buf + ctx->pos)[7] != 'm' ||
                (ctx->buffer.buf + ctx->pos)[8] != 'p'
            ) goto L0010;
            ctx->pos += 9;
        }
        {
            pcc_thunk_t *const thunk = pcc_thunk__create_leaf(ctx->auxil, pcc_action_builtin_type_name_8, 0, 0);
            thunk->data.leaf.capt0.range.start = chunk->pos;
            thunk->data.leaf.capt0.range.end = ctx->pos;
            pcc_thunk_array__add(ctx->auxil, &chunk->thunks, thunk);
        }
        goto L0001;
    L0010:;
        ctx->pos = p;
        pcc_thunk_array__revert(ctx->auxil, &chunk->thunks, n);
        {
            if (
                pcc_refill_buffer(ctx, 7) < 7 ||
                (ctx->buffer.buf + ctx->pos)[0] != 'p' ||
                (ctx->buffer.buf + ctx->pos)[1] != 'o' ||
                (ctx->buffer.buf + ctx->pos)[2] != 'i' ||
                (ctx->buffer.buf + ctx->pos)[3] != 'n' ||
                (ctx->buffer.buf + ctx->pos)[4] != 't' ||
                (ctx->buffer.buf + ctx->pos)[5] != 'e' ||
                (ctx->buffer.buf + ctx->pos)[6] != 'r'
            ) goto L0011;
            ctx->pos += 7;
        }
        {
            pcc_thunk_t *const thunk = pcc_thunk__create_leaf(ctx->auxil, pcc_action_builtin_type_name_9, 0, 0);
            thunk->data.leaf.capt0.range.start = chunk->pos;
            thunk->data.leaf.capt0.range.end = ctx->pos;
            pcc_thunk_array__add(ctx->auxil, &chunk->thunks, thunk);
        }
        goto L0001;
    L0011:;
        ctx->pos = p;
        pcc_thunk_array__revert(ctx->auxil, &chunk->thunks, n);
        goto L0000;
    L0001:;
    }
    return chunk;
L0000:;
    pcc_thunk_chunk__destroy(ctx->auxil, chunk);
    return NULL;
}

static pcc_thunk_chunk_t *pcc_evaluate_rule_user_type_name(mstro_stp_context_t *ctx) {
    pcc_thunk_chunk_t *const chunk = pcc_thunk_chunk__create(ctx->auxil);
    chunk->pos = ctx->pos;
    pcc_value_table__resize(ctx->auxil, &chunk->values, 1);
    pcc_capture_table__resize(ctx->auxil, &chunk->capts, 0);
    if (!pcc_apply_rule(ctx, pcc_evaluate_rule_identifier, &chunk->thunks, &(chunk->values.buf[0]))) goto L0000;
    {
        pcc_thunk_t *const thunk = pcc_thunk__create_leaf(ctx->auxil, pcc_action_user_type_name_0, 1, 0);
        thunk->data.leaf.values.buf[0] = &(chunk->values.buf[0]);
        thunk->data.leaf.capt0.range.start = chunk->pos;
        thunk->data.leaf.capt0.range.end = ctx->pos;
        pcc_thunk_array__add(ctx->auxil, &chunk->thunks, thunk);
    }
    return chunk;
L0000:;
    pcc_thunk_chunk__destroy(ctx->auxil, chunk);
    return NULL;
}

static pcc_thunk_chunk_t *pcc_evaluate_rule_type_arguments(mstro_stp_context_t *ctx) {
    pcc_thunk_chunk_t *const chunk = pcc_thunk_chunk__create(ctx->auxil);
    chunk->pos = ctx->pos;
    pcc_value_table__resize(ctx->auxil, &chunk->values, 2);
    pcc_capture_table__resize(ctx->auxil, &chunk->capts, 0);
    {
        const int p = ctx->pos;
        const int n = chunk->thunks.len;
        if (
            pcc_refill_buffer(ctx, 1) < 1 ||
            ctx->buffer.buf[ctx->pos] != '('
        ) goto L0002;
        ctx->pos++;
        if (!pcc_apply_rule(ctx, pcc_evaluate_rule_unnamed_args, &chunk->thunks, &(chunk->values.buf[0]))) goto L0002;
        if (
            pcc_refill_buffer(ctx, 1) < 1 ||
            ctx->buffer.buf[ctx->pos] != ','
        ) goto L0002;
        ctx->pos++;
        if (!pcc_apply_rule(ctx, pcc_evaluate_rule_type_restriction_list, &chunk->thunks, &(chunk->values.buf[1]))) goto L0002;
        if (
            pcc_refill_buffer(ctx, 1) < 1 ||
            ctx->buffer.buf[ctx->pos] != ')'
        ) goto L0002;
        ctx->pos++;
        {
            pcc_thunk_t *const thunk = pcc_thunk__create_leaf(ctx->auxil, pcc_action_type_arguments_0, 2, 0);
            thunk->data.leaf.values.buf[0] = &(chunk->values.buf[0]);
            thunk->data.leaf.values.buf[1] = &(chunk->values.buf[1]);
            thunk->data.leaf.capt0.range.start = chunk->pos;
            thunk->data.leaf.capt0.range.end = ctx->pos;
            pcc_thunk_array__add(ctx->auxil, &chunk->thunks, thunk);
        }
        goto L0001;
    L0002:;
        ctx->pos = p;
        pcc_thunk_array__revert(ctx->auxil, &chunk->thunks, n);
        if (
            pcc_refill_buffer(ctx, 1) < 1 ||
            ctx->buffer.buf[ctx->pos] != '('
        ) goto L0003;
        ctx->pos++;
        if (!pcc_apply_rule(ctx, pcc_evaluate_rule_unnamed_args, &chunk->thunks, &(chunk->values.buf[0]))) goto L0003;
        if (
            pcc_refill_buffer(ctx, 1) < 1 ||
            ctx->buffer.buf[ctx->pos] != ')'
        ) goto L0003;
        ctx->pos++;
        {
            pcc_thunk_t *const thunk = pcc_thunk__create_leaf(ctx->auxil, pcc_action_type_arguments_1, 2, 0);
            thunk->data.leaf.values.buf[0] = &(chunk->values.buf[0]);
            thunk->data.leaf.capt0.range.start = chunk->pos;
            thunk->data.leaf.capt0.range.end = ctx->pos;
            pcc_thunk_array__add(ctx->auxil, &chunk->thunks, thunk);
        }
        goto L0001;
    L0003:;
        ctx->pos = p;
        pcc_thunk_array__revert(ctx->auxil, &chunk->thunks, n);
        if (
            pcc_refill_buffer(ctx, 1) < 1 ||
            ctx->buffer.buf[ctx->pos] != '('
        ) goto L0004;
        ctx->pos++;
        if (!pcc_apply_rule(ctx, pcc_evaluate_rule_type_restriction_list, &chunk->thunks, &(chunk->values.buf[1]))) goto L0004;
        if (
            pcc_refill_buffer(ctx, 1) < 1 ||
            ctx->buffer.buf[ctx->pos] != ')'
        ) goto L0004;
        ctx->pos++;
        {
            pcc_thunk_t *const thunk = pcc_thunk__create_leaf(ctx->auxil, pcc_action_type_arguments_2, 2, 0);
            thunk->data.leaf.values.buf[1] = &(chunk->values.buf[1]);
            thunk->data.leaf.capt0.range.start = chunk->pos;
            thunk->data.leaf.capt0.range.end = ctx->pos;
            pcc_thunk_array__add(ctx->auxil, &chunk->thunks, thunk);
        }
        goto L0001;
    L0004:;
        ctx->pos = p;
        pcc_thunk_array__revert(ctx->auxil, &chunk->thunks, n);
        if (
            pcc_refill_buffer(ctx, 1) < 1 ||
            ctx->buffer.buf[ctx->pos] != '('
        ) goto L0005;
        ctx->pos++;
        {
            int i;
            for (i = 0;; i++) {
                if (!pcc_apply_rule(ctx, pcc_evaluate_rule_space, &chunk->thunks, NULL)) goto L0006;
            }
        L0006:;
        }
        if (
            pcc_refill_buffer(ctx, 1) < 1 ||
            ctx->buffer.buf[ctx->pos] != ')'
        ) goto L0005;
        ctx->pos++;
        {
            pcc_thunk_t *const thunk = pcc_thunk__create_leaf(ctx->auxil, pcc_action_type_arguments_3, 2, 0);
            thunk->data.leaf.capt0.range.start = chunk->pos;
            thunk->data.leaf.capt0.range.end = ctx->pos;
            pcc_thunk_array__add(ctx->auxil, &chunk->thunks, thunk);
        }
        goto L0001;
    L0005:;
        ctx->pos = p;
        pcc_thunk_array__revert(ctx->auxil, &chunk->thunks, n);
        goto L0000;
    L0001:;
    }
    return chunk;
L0000:;
    pcc_thunk_chunk__destroy(ctx->auxil, chunk);
    return NULL;
}

static pcc_thunk_chunk_t *pcc_evaluate_rule_type_restriction_list(mstro_stp_context_t *ctx) {
    pcc_thunk_chunk_t *const chunk = pcc_thunk_chunk__create(ctx->auxil);
    chunk->pos = ctx->pos;
    pcc_value_table__resize(ctx->auxil, &chunk->values, 2);
    pcc_capture_table__resize(ctx->auxil, &chunk->capts, 0);
    {
        const int p = ctx->pos;
        const int n = chunk->thunks.len;
        if (!pcc_apply_rule(ctx, pcc_evaluate_rule_type_restriction, &chunk->thunks, &(chunk->values.buf[0]))) goto L0002;
        {
            int i;
            for (i = 0;; i++) {
                if (!pcc_apply_rule(ctx, pcc_evaluate_rule_space, &chunk->thunks, NULL)) goto L0003;
            }
        L0003:;
        }
        if (
            pcc_refill_buffer(ctx, 1) < 1 ||
            ctx->buffer.buf[ctx->pos] != ','
        ) goto L0002;
        ctx->pos++;
        if (!pcc_apply_rule(ctx, pcc_evaluate_rule_type_restriction_list, &chunk->thunks, &(chunk->values.buf[1]))) goto L0002;
        {
            pcc_thunk_t *const thunk = pcc_thunk__create_leaf(ctx->auxil, pcc_action_type_restriction_list_0, 2, 0);
            thunk->data.leaf.values.buf[0] = &(chunk->values.buf[0]);
            thunk->data.leaf.values.buf[1] = &(chunk->values.buf[1]);
            thunk->data.leaf.capt0.range.start = chunk->pos;
            thunk->data.leaf.capt0.range.end = ctx->pos;
            pcc_thunk_array__add(ctx->auxil, &chunk->thunks, thunk);
        }
        goto L0001;
    L0002:;
        ctx->pos = p;
        pcc_thunk_array__revert(ctx->auxil, &chunk->thunks, n);
        if (!pcc_apply_rule(ctx, pcc_evaluate_rule_type_restriction, &chunk->thunks, &(chunk->values.buf[0]))) goto L0004;
        {
            pcc_thunk_t *const thunk = pcc_thunk__create_leaf(ctx->auxil, pcc_action_type_restriction_list_1, 2, 0);
            thunk->data.leaf.values.buf[0] = &(chunk->values.buf[0]);
            thunk->data.leaf.capt0.range.start = chunk->pos;
            thunk->data.leaf.capt0.range.end = ctx->pos;
            pcc_thunk_array__add(ctx->auxil, &chunk->thunks, thunk);
        }
        goto L0001;
    L0004:;
        ctx->pos = p;
        pcc_thunk_array__revert(ctx->auxil, &chunk->thunks, n);
        goto L0000;
    L0001:;
    }
    return chunk;
L0000:;
    pcc_thunk_chunk__destroy(ctx->auxil, chunk);
    return NULL;
}

static pcc_thunk_chunk_t *pcc_evaluate_rule_type_restriction(mstro_stp_context_t *ctx) {
    pcc_thunk_chunk_t *const chunk = pcc_thunk_chunk__create(ctx->auxil);
    chunk->pos = ctx->pos;
    pcc_value_table__resize(ctx->auxil, &chunk->values, 3);
    pcc_capture_table__resize(ctx->auxil, &chunk->capts, 0);
    {
        const int p = ctx->pos;
        const int n = chunk->thunks.len;
        {
            int i;
            for (i = 0;; i++) {
                if (!pcc_apply_rule(ctx, pcc_evaluate_rule_space, &chunk->thunks, NULL)) goto L0003;
            }
        L0003:;
        }
        {
            char c;
            if (pcc_refill_buffer(ctx, 1) < 1) goto L0002;
            c = ctx->buffer.buf[ctx->pos];
            if (!(
                c == 'M' ||
                c == 'm'
            )) goto L0002;
            ctx->pos++;
        }
        {
            char c;
            if (pcc_refill_buffer(ctx, 1) < 1) goto L0002;
            c = ctx->buffer.buf[ctx->pos];
            if (!(
                c == 'I' ||
                c == 'i'
            )) goto L0002;
            ctx->pos++;
        }
        {
            char c;
            if (pcc_refill_buffer(ctx, 1) < 1) goto L0002;
            c = ctx->buffer.buf[ctx->pos];
            if (!(
                c == 'N' ||
                c == 'n'
            )) goto L0002;
            ctx->pos++;
        }
        {
            int i;
            for (i = 0;; i++) {
                if (!pcc_apply_rule(ctx, pcc_evaluate_rule_space, &chunk->thunks, NULL)) goto L0004;
            }
        L0004:;
        }
        if (
            pcc_refill_buffer(ctx, 1) < 1 ||
            ctx->buffer.buf[ctx->pos] != '='
        ) goto L0002;
        ctx->pos++;
        if (!pcc_apply_rule(ctx, pcc_evaluate_rule_number, &chunk->thunks, &(chunk->values.buf[0]))) goto L0002;
        {
            pcc_thunk_t *const thunk = pcc_thunk__create_leaf(ctx->auxil, pcc_action_type_restriction_0, 3, 0);
            thunk->data.leaf.values.buf[0] = &(chunk->values.buf[0]);
            thunk->data.leaf.capt0.range.start = chunk->pos;
            thunk->data.leaf.capt0.range.end = ctx->pos;
            pcc_thunk_array__add(ctx->auxil, &chunk->thunks, thunk);
        }
        goto L0001;
    L0002:;
        ctx->pos = p;
        pcc_thunk_array__revert(ctx->auxil, &chunk->thunks, n);
        {
            int i;
            for (i = 0;; i++) {
                if (!pcc_apply_rule(ctx, pcc_evaluate_rule_space, &chunk->thunks, NULL)) goto L0006;
            }
        L0006:;
        }
        {
            char c;
            if (pcc_refill_buffer(ctx, 1) < 1) goto L0005;
            c = ctx->buffer.buf[ctx->pos];
            if (!(
                c == 'M' ||
                c == 'm'
            )) goto L0005;
            ctx->pos++;
        }
        {
            char c;
            if (pcc_refill_buffer(ctx, 1) < 1) goto L0005;
            c = ctx->buffer.buf[ctx->pos];
            if (!(
                c == 'A' ||
                c == 'a'
            )) goto L0005;
            ctx->pos++;
        }
        {
            char c;
            if (pcc_refill_buffer(ctx, 1) < 1) goto L0005;
            c = ctx->buffer.buf[ctx->pos];
            if (!(
                c == 'X' ||
                c == 'x'
            )) goto L0005;
            ctx->pos++;
        }
        {
            int i;
            for (i = 0;; i++) {
                if (!pcc_apply_rule(ctx, pcc_evaluate_rule_space, &chunk->thunks, NULL)) goto L0007;
            }
        L0007:;
        }
        if (
            pcc_refill_buffer(ctx, 1) < 1 ||
            ctx->buffer.buf[ctx->pos] != '='
        ) goto L0005;
        ctx->pos++;
        if (!pcc_apply_rule(ctx, pcc_evaluate_rule_number, &chunk->thunks, &(chunk->values.buf[0]))) goto L0005;
        {
            pcc_thunk_t *const thunk = pcc_thunk__create_leaf(ctx->auxil, pcc_action_type_restriction_1, 3, 0);
            thunk->data.leaf.values.buf[0] = &(chunk->values.buf[0]);
            thunk->data.leaf.capt0.range.start = chunk->pos;
            thunk->data.leaf.capt0.range.end = ctx->pos;
            pcc_thunk_array__add(ctx->auxil, &chunk->thunks, thunk);
        }
        goto L0001;
    L0005:;
        ctx->pos = p;
        pcc_thunk_array__revert(ctx->auxil, &chunk->thunks, n);
        {
            int i;
            for (i = 0;; i++) {
                if (!pcc_apply_rule(ctx, pcc_evaluate_rule_space, &chunk->thunks, NULL)) goto L0009;
            }
        L0009:;
        }
        {
            char c;
            if (pcc_refill_buffer(ctx, 1) < 1) goto L0008;
            c = ctx->buffer.buf[ctx->pos];
            if (!(
                c == 'E' ||
                c == 'e'
            )) goto L0008;
            ctx->pos++;
        }
        {
            char c;
            if (pcc_refill_buffer(ctx, 1) < 1) goto L0008;
            c = ctx->buffer.buf[ctx->pos];
            if (!(
                c == 'X' ||
                c == 'x'
            )) goto L0008;
            ctx->pos++;
        }
        {
            char c;
            if (pcc_refill_buffer(ctx, 1) < 1) goto L0008;
            c = ctx->buffer.buf[ctx->pos];
            if (!(
                c == 'C' ||
                c == 'c'
            )) goto L0008;
            ctx->pos++;
        }
        {
            char c;
            if (pcc_refill_buffer(ctx, 1) < 1) goto L0008;
            c = ctx->buffer.buf[ctx->pos];
            if (!(
                c == 'L' ||
                c == 'l'
            )) goto L0008;
            ctx->pos++;
        }
        {
            char c;
            if (pcc_refill_buffer(ctx, 1) < 1) goto L0008;
            c = ctx->buffer.buf[ctx->pos];
            if (!(
                c == 'U' ||
                c == 'u'
            )) goto L0008;
            ctx->pos++;
        }
        {
            char c;
            if (pcc_refill_buffer(ctx, 1) < 1) goto L0008;
            c = ctx->buffer.buf[ctx->pos];
            if (!(
                c == 'D' ||
                c == 'd'
            )) goto L0008;
            ctx->pos++;
        }
        {
            char c;
            if (pcc_refill_buffer(ctx, 1) < 1) goto L0008;
            c = ctx->buffer.buf[ctx->pos];
            if (!(
                c == 'E' ||
                c == 'e'
            )) goto L0008;
            ctx->pos++;
        }
        {
            int i;
            for (i = 0;; i++) {
                if (!pcc_apply_rule(ctx, pcc_evaluate_rule_space, &chunk->thunks, NULL)) goto L0010;
            }
        L0010:;
        }
        if (
            pcc_refill_buffer(ctx, 1) < 1 ||
            ctx->buffer.buf[ctx->pos] != '='
        ) goto L0008;
        ctx->pos++;
        if (!pcc_apply_rule(ctx, pcc_evaluate_rule_string, &chunk->thunks, &(chunk->values.buf[1]))) goto L0008;
        {
            pcc_thunk_t *const thunk = pcc_thunk__create_leaf(ctx->auxil, pcc_action_type_restriction_2, 3, 0);
            thunk->data.leaf.values.buf[1] = &(chunk->values.buf[1]);
            thunk->data.leaf.capt0.range.start = chunk->pos;
            thunk->data.leaf.capt0.range.end = ctx->pos;
            pcc_thunk_array__add(ctx->auxil, &chunk->thunks, thunk);
        }
        goto L0001;
    L0008:;
        ctx->pos = p;
        pcc_thunk_array__revert(ctx->auxil, &chunk->thunks, n);
        {
            int i;
            for (i = 0;; i++) {
                if (!pcc_apply_rule(ctx, pcc_evaluate_rule_space, &chunk->thunks, NULL)) goto L0012;
            }
        L0012:;
        }
        {
            char c;
            if (pcc_refill_buffer(ctx, 1) < 1) goto L0011;
            c = ctx->buffer.buf[ctx->pos];
            if (!(
                c == 'I' ||
                c == 'i'
            )) goto L0011;
            ctx->pos++;
        }
        {
            char c;
            if (pcc_refill_buffer(ctx, 1) < 1) goto L0011;
            c = ctx->buffer.buf[ctx->pos];
            if (!(
                c == 'G' ||
                c == 'g'
            )) goto L0011;
            ctx->pos++;
        }
        {
            char c;
            if (pcc_refill_buffer(ctx, 1) < 1) goto L0011;
            c = ctx->buffer.buf[ctx->pos];
            if (!(
                c == 'N' ||
                c == 'n'
            )) goto L0011;
            ctx->pos++;
        }
        {
            char c;
            if (pcc_refill_buffer(ctx, 1) < 1) goto L0011;
            c = ctx->buffer.buf[ctx->pos];
            if (!(
                c == 'O' ||
                c == 'o'
            )) goto L0011;
            ctx->pos++;
        }
        {
            char c;
            if (pcc_refill_buffer(ctx, 1) < 1) goto L0011;
            c = ctx->buffer.buf[ctx->pos];
            if (!(
                c == 'R' ||
                c == 'r'
            )) goto L0011;
            ctx->pos++;
        }
        {
            char c;
            if (pcc_refill_buffer(ctx, 1) < 1) goto L0011;
            c = ctx->buffer.buf[ctx->pos];
            if (!(
                c == 'E' ||
                c == 'e'
            )) goto L0011;
            ctx->pos++;
        }
        {
            char c;
            if (pcc_refill_buffer(ctx, 1) < 1) goto L0011;
            c = ctx->buffer.buf[ctx->pos];
            if (!(
                c == '-' ||
                c == '_'
            )) goto L0011;
            ctx->pos++;
        }
        {
            char c;
            if (pcc_refill_buffer(ctx, 1) < 1) goto L0011;
            c = ctx->buffer.buf[ctx->pos];
            if (!(
                c == 'C' ||
                c == 'c'
            )) goto L0011;
            ctx->pos++;
        }
        {
            char c;
            if (pcc_refill_buffer(ctx, 1) < 1) goto L0011;
            c = ctx->buffer.buf[ctx->pos];
            if (!(
                c == 'A' ||
                c == 'a'
            )) goto L0011;
            ctx->pos++;
        }
        {
            char c;
            if (pcc_refill_buffer(ctx, 1) < 1) goto L0011;
            c = ctx->buffer.buf[ctx->pos];
            if (!(
                c == 'S' ||
                c == 's'
            )) goto L0011;
            ctx->pos++;
        }
        {
            char c;
            if (pcc_refill_buffer(ctx, 1) < 1) goto L0011;
            c = ctx->buffer.buf[ctx->pos];
            if (!(
                c == 'E' ||
                c == 'e'
            )) goto L0011;
            ctx->pos++;
        }
        {
            int i;
            for (i = 0;; i++) {
                if (!pcc_apply_rule(ctx, pcc_evaluate_rule_space, &chunk->thunks, NULL)) goto L0013;
            }
        L0013:;
        }
        if (
            pcc_refill_buffer(ctx, 1) < 1 ||
            ctx->buffer.buf[ctx->pos] != '='
        ) goto L0011;
        ctx->pos++;
        if (!pcc_apply_rule(ctx, pcc_evaluate_rule_bool, &chunk->thunks, &(chunk->values.buf[2]))) goto L0011;
        {
            pcc_thunk_t *const thunk = pcc_thunk__create_leaf(ctx->auxil, pcc_action_type_restriction_3, 3, 0);
            thunk->data.leaf.values.buf[2] = &(chunk->values.buf[2]);
            thunk->data.leaf.capt0.range.start = chunk->pos;
            thunk->data.leaf.capt0.range.end = ctx->pos;
            pcc_thunk_array__add(ctx->auxil, &chunk->thunks, thunk);
        }
        goto L0001;
    L0011:;
        ctx->pos = p;
        pcc_thunk_array__revert(ctx->auxil, &chunk->thunks, n);
        {
            int i;
            for (i = 0;; i++) {
                if (!pcc_apply_rule(ctx, pcc_evaluate_rule_space, &chunk->thunks, NULL)) goto L0015;
            }
        L0015:;
        }
        {
            char c;
            if (pcc_refill_buffer(ctx, 1) < 1) goto L0014;
            c = ctx->buffer.buf[ctx->pos];
            if (!(
                c == 'N' ||
                c == 'n'
            )) goto L0014;
            ctx->pos++;
        }
        {
            char c;
            if (pcc_refill_buffer(ctx, 1) < 1) goto L0014;
            c = ctx->buffer.buf[ctx->pos];
            if (!(
                c == 'A' ||
                c == 'a'
            )) goto L0014;
            ctx->pos++;
        }
        {
            char c;
            if (pcc_refill_buffer(ctx, 1) < 1) goto L0014;
            c = ctx->buffer.buf[ctx->pos];
            if (!(
                c == 'M' ||
                c == 'm'
            )) goto L0014;
            ctx->pos++;
        }
        {
            char c;
            if (pcc_refill_buffer(ctx, 1) < 1) goto L0014;
            c = ctx->buffer.buf[ctx->pos];
            if (!(
                c == 'E' ||
                c == 'e'
            )) goto L0014;
            ctx->pos++;
        }
        {
            int i;
            for (i = 0;; i++) {
                if (!pcc_apply_rule(ctx, pcc_evaluate_rule_space, &chunk->thunks, NULL)) goto L0016;
            }
        L0016:;
        }
        if (
            pcc_refill_buffer(ctx, 1) < 1 ||
            ctx->buffer.buf[ctx->pos] != '='
        ) goto L0014;
        ctx->pos++;
        if (!pcc_apply_rule(ctx, pcc_evaluate_rule_string, &chunk->thunks, &(chunk->values.buf[1]))) goto L0014;
        {
            pcc_thunk_t *const thunk = pcc_thunk__create_leaf(ctx->auxil, pcc_action_type_restriction_4, 3, 0);
            thunk->data.leaf.values.buf[1] = &(chunk->values.buf[1]);
            thunk->data.leaf.capt0.range.start = chunk->pos;
            thunk->data.leaf.capt0.range.end = ctx->pos;
            pcc_thunk_array__add(ctx->auxil, &chunk->thunks, thunk);
        }
        goto L0001;
    L0014:;
        ctx->pos = p;
        pcc_thunk_array__revert(ctx->auxil, &chunk->thunks, n);
        goto L0000;
    L0001:;
    }
    return chunk;
L0000:;
    pcc_thunk_chunk__destroy(ctx->auxil, chunk);
    return NULL;
}

static pcc_thunk_chunk_t *pcc_evaluate_rule_unnamed_args(mstro_stp_context_t *ctx) {
    pcc_thunk_chunk_t *const chunk = pcc_thunk_chunk__create(ctx->auxil);
    chunk->pos = ctx->pos;
    pcc_value_table__resize(ctx->auxil, &chunk->values, 4);
    pcc_capture_table__resize(ctx->auxil, &chunk->capts, 0);
    {
        const int p = ctx->pos;
        const int n = chunk->thunks.len;
        if (!pcc_apply_rule(ctx, pcc_evaluate_rule_restricted_type, &chunk->thunks, &(chunk->values.buf[0]))) goto L0002;
        if (
            pcc_refill_buffer(ctx, 1) < 1 ||
            ctx->buffer.buf[ctx->pos] != ','
        ) goto L0002;
        ctx->pos++;
        if (!pcc_apply_rule(ctx, pcc_evaluate_rule_unnamed_args, &chunk->thunks, &(chunk->values.buf[1]))) goto L0002;
        {
            pcc_thunk_t *const thunk = pcc_thunk__create_leaf(ctx->auxil, pcc_action_unnamed_args_0, 4, 0);
            thunk->data.leaf.values.buf[0] = &(chunk->values.buf[0]);
            thunk->data.leaf.values.buf[1] = &(chunk->values.buf[1]);
            thunk->data.leaf.capt0.range.start = chunk->pos;
            thunk->data.leaf.capt0.range.end = ctx->pos;
            pcc_thunk_array__add(ctx->auxil, &chunk->thunks, thunk);
        }
        goto L0001;
    L0002:;
        ctx->pos = p;
        pcc_thunk_array__revert(ctx->auxil, &chunk->thunks, n);
        {
            int i;
            for (i = 0;; i++) {
                if (!pcc_apply_rule(ctx, pcc_evaluate_rule_space, &chunk->thunks, NULL)) goto L0004;
            }
        L0004:;
        }
        if (!pcc_apply_rule(ctx, pcc_evaluate_rule_string, &chunk->thunks, &(chunk->values.buf[2]))) goto L0003;
        if (
            pcc_refill_buffer(ctx, 1) < 1 ||
            ctx->buffer.buf[ctx->pos] != ','
        ) goto L0003;
        ctx->pos++;
        if (!pcc_apply_rule(ctx, pcc_evaluate_rule_unnamed_args, &chunk->thunks, &(chunk->values.buf[1]))) goto L0003;
        {
            pcc_thunk_t *const thunk = pcc_thunk__create_leaf(ctx->auxil, pcc_action_unnamed_args_1, 4, 0);
            thunk->data.leaf.values.buf[2] = &(chunk->values.buf[2]);
            thunk->data.leaf.values.buf[1] = &(chunk->values.buf[1]);
            thunk->data.leaf.capt0.range.start = chunk->pos;
            thunk->data.leaf.capt0.range.end = ctx->pos;
            pcc_thunk_array__add(ctx->auxil, &chunk->thunks, thunk);
        }
        goto L0001;
    L0003:;
        ctx->pos = p;
        pcc_thunk_array__revert(ctx->auxil, &chunk->thunks, n);
        {
            int i;
            for (i = 0;; i++) {
                if (!pcc_apply_rule(ctx, pcc_evaluate_rule_space, &chunk->thunks, NULL)) goto L0006;
            }
        L0006:;
        }
        if (!pcc_apply_rule(ctx, pcc_evaluate_rule_restricted_type, &chunk->thunks, &(chunk->values.buf[3]))) goto L0005;
        {
            pcc_thunk_t *const thunk = pcc_thunk__create_leaf(ctx->auxil, pcc_action_unnamed_args_2, 4, 0);
            thunk->data.leaf.values.buf[3] = &(chunk->values.buf[3]);
            thunk->data.leaf.capt0.range.start = chunk->pos;
            thunk->data.leaf.capt0.range.end = ctx->pos;
            pcc_thunk_array__add(ctx->auxil, &chunk->thunks, thunk);
        }
        goto L0001;
    L0005:;
        ctx->pos = p;
        pcc_thunk_array__revert(ctx->auxil, &chunk->thunks, n);
        {
            int i;
            for (i = 0;; i++) {
                if (!pcc_apply_rule(ctx, pcc_evaluate_rule_space, &chunk->thunks, NULL)) goto L0008;
            }
        L0008:;
        }
        if (!pcc_apply_rule(ctx, pcc_evaluate_rule_string, &chunk->thunks, &(chunk->values.buf[2]))) goto L0007;
        {
            pcc_thunk_t *const thunk = pcc_thunk__create_leaf(ctx->auxil, pcc_action_unnamed_args_3, 4, 0);
            thunk->data.leaf.values.buf[2] = &(chunk->values.buf[2]);
            thunk->data.leaf.capt0.range.start = chunk->pos;
            thunk->data.leaf.capt0.range.end = ctx->pos;
            pcc_thunk_array__add(ctx->auxil, &chunk->thunks, thunk);
        }
        goto L0001;
    L0007:;
        ctx->pos = p;
        pcc_thunk_array__revert(ctx->auxil, &chunk->thunks, n);
        goto L0000;
    L0001:;
    }
    return chunk;
L0000:;
    pcc_thunk_chunk__destroy(ctx->auxil, chunk);
    return NULL;
}

static pcc_thunk_chunk_t *pcc_evaluate_rule_identifier(mstro_stp_context_t *ctx) {
    pcc_thunk_chunk_t *const chunk = pcc_thunk_chunk__create(ctx->auxil);
    chunk->pos = ctx->pos;
    pcc_value_table__resize(ctx->auxil, &chunk->values, 0);
    pcc_capture_table__resize(ctx->auxil, &chunk->capts, 1);
    {
        const int p = ctx->pos;
        int q;
        {
            char c;
            if (pcc_refill_buffer(ctx, 1) < 1) goto L0000;
            c = ctx->buffer.buf[ctx->pos];
            if (!(
                c == '-' ||
                c == '.' ||
                c == ':' ||
                (c >= 'A' && c <= 'Z') ||
                (c >= 'a' && c <= 'z')
            )) goto L0000;
            ctx->pos++;
        }
        {
            int i;
            for (i = 0;; i++) {
                char c;
                if (pcc_refill_buffer(ctx, 1) < 1) goto L0001;
                c = ctx->buffer.buf[ctx->pos];
                if (!(
                    c == '-' ||
                    c == '.' ||
                    c == ':' ||
                    (c >= 'A' && c <= 'Z') ||
                    (c >= 'a' && c <= 'z') ||
                    (c >= '0' && c <= '9')
                )) goto L0001;
                ctx->pos++;
            }
        L0001:;
        }
        q = ctx->pos;
        chunk->capts.buf[0].range.start = p;
        chunk->capts.buf[0].range.end = q;
    }
    {
        pcc_thunk_t *const thunk = pcc_thunk__create_leaf(ctx->auxil, pcc_action_identifier_0, 0, 1);
        thunk->data.leaf.capts.buf[0] = &(chunk->capts.buf[0]);
        thunk->data.leaf.capt0.range.start = chunk->pos;
        thunk->data.leaf.capt0.range.end = ctx->pos;
        pcc_thunk_array__add(ctx->auxil, &chunk->thunks, thunk);
    }
    return chunk;
L0000:;
    pcc_thunk_chunk__destroy(ctx->auxil, chunk);
    return NULL;
}

static pcc_thunk_chunk_t *pcc_evaluate_rule_string(mstro_stp_context_t *ctx) {
    pcc_thunk_chunk_t *const chunk = pcc_thunk_chunk__create(ctx->auxil);
    chunk->pos = ctx->pos;
    pcc_value_table__resize(ctx->auxil, &chunk->values, 0);
    pcc_capture_table__resize(ctx->auxil, &chunk->capts, 2);
    {
        const int p = ctx->pos;
        const int n = chunk->thunks.len;
        if (
            pcc_refill_buffer(ctx, 1) < 1 ||
            ctx->buffer.buf[ctx->pos] != '\"'
        ) goto L0002;
        ctx->pos++;
        {
            const int p = ctx->pos;
            int q;
            {
                int i;
                for (i = 0;; i++) {
                    if (
                        pcc_refill_buffer(ctx, 1) < 1 ||
                        ctx->buffer.buf[ctx->pos] == '\"'
                    ) goto L0003;
                    ctx->pos++;
                }
            L0003:;
            }
            q = ctx->pos;
            chunk->capts.buf[0].range.start = p;
            chunk->capts.buf[0].range.end = q;
        }
        if (
            pcc_refill_buffer(ctx, 1) < 1 ||
            ctx->buffer.buf[ctx->pos] != '\"'
        ) goto L0002;
        ctx->pos++;
        {
            pcc_thunk_t *const thunk = pcc_thunk__create_leaf(ctx->auxil, pcc_action_string_0, 0, 2);
            thunk->data.leaf.capts.buf[0] = &(chunk->capts.buf[0]);
            thunk->data.leaf.capt0.range.start = chunk->pos;
            thunk->data.leaf.capt0.range.end = ctx->pos;
            pcc_thunk_array__add(ctx->auxil, &chunk->thunks, thunk);
        }
        goto L0001;
    L0002:;
        ctx->pos = p;
        pcc_thunk_array__revert(ctx->auxil, &chunk->thunks, n);
        if (
            pcc_refill_buffer(ctx, 1) < 1 ||
            ctx->buffer.buf[ctx->pos] != '\''
        ) goto L0004;
        ctx->pos++;
        {
            const int p = ctx->pos;
            int q;
            {
                int i;
                for (i = 0;; i++) {
                    if (
                        pcc_refill_buffer(ctx, 1) < 1 ||
                        ctx->buffer.buf[ctx->pos] == '\''
                    ) goto L0005;
                    ctx->pos++;
                }
            L0005:;
            }
            q = ctx->pos;
            chunk->capts.buf[1].range.start = p;
            chunk->capts.buf[1].range.end = q;
        }
        if (
            pcc_refill_buffer(ctx, 1) < 1 ||
            ctx->buffer.buf[ctx->pos] != '\''
        ) goto L0004;
        ctx->pos++;
        {
            pcc_thunk_t *const thunk = pcc_thunk__create_leaf(ctx->auxil, pcc_action_string_1, 0, 2);
            thunk->data.leaf.capts.buf[1] = &(chunk->capts.buf[1]);
            thunk->data.leaf.capt0.range.start = chunk->pos;
            thunk->data.leaf.capt0.range.end = ctx->pos;
            pcc_thunk_array__add(ctx->auxil, &chunk->thunks, thunk);
        }
        goto L0001;
    L0004:;
        ctx->pos = p;
        pcc_thunk_array__revert(ctx->auxil, &chunk->thunks, n);
        goto L0000;
    L0001:;
    }
    return chunk;
L0000:;
    pcc_thunk_chunk__destroy(ctx->auxil, chunk);
    return NULL;
}

static pcc_thunk_chunk_t *pcc_evaluate_rule_bool(mstro_stp_context_t *ctx) {
    pcc_thunk_chunk_t *const chunk = pcc_thunk_chunk__create(ctx->auxil);
    chunk->pos = ctx->pos;
    pcc_value_table__resize(ctx->auxil, &chunk->values, 0);
    pcc_capture_table__resize(ctx->auxil, &chunk->capts, 0);
    {
        const int p = ctx->pos;
        const int n = chunk->thunks.len;
        if (
            pcc_refill_buffer(ctx, 1) < 1 ||
            ctx->buffer.buf[ctx->pos] != '1'
        ) goto L0002;
        ctx->pos++;
        {
            pcc_thunk_t *const thunk = pcc_thunk__create_leaf(ctx->auxil, pcc_action_bool_0, 0, 0);
            thunk->data.leaf.capt0.range.start = chunk->pos;
            thunk->data.leaf.capt0.range.end = ctx->pos;
            pcc_thunk_array__add(ctx->auxil, &chunk->thunks, thunk);
        }
        goto L0001;
    L0002:;
        ctx->pos = p;
        pcc_thunk_array__revert(ctx->auxil, &chunk->thunks, n);
        if (
            pcc_refill_buffer(ctx, 1) < 1 ||
            ctx->buffer.buf[ctx->pos] != '0'
        ) goto L0003;
        ctx->pos++;
        {
            pcc_thunk_t *const thunk = pcc_thunk__create_leaf(ctx->auxil, pcc_action_bool_1, 0, 0);
            thunk->data.leaf.capt0.range.start = chunk->pos;
            thunk->data.leaf.capt0.range.end = ctx->pos;
            pcc_thunk_array__add(ctx->auxil, &chunk->thunks, thunk);
        }
        goto L0001;
    L0003:;
        ctx->pos = p;
        pcc_thunk_array__revert(ctx->auxil, &chunk->thunks, n);
        {
            char c;
            if (pcc_refill_buffer(ctx, 1) < 1) goto L0004;
            c = ctx->buffer.buf[ctx->pos];
            if (!(
                c == 'F' ||
                c == 'f'
            )) goto L0004;
            ctx->pos++;
        }
        {
            char c;
            if (pcc_refill_buffer(ctx, 1) < 1) goto L0004;
            c = ctx->buffer.buf[ctx->pos];
            if (!(
                c == 'A' ||
                c == 'a'
            )) goto L0004;
            ctx->pos++;
        }
        {
            char c;
            if (pcc_refill_buffer(ctx, 1) < 1) goto L0004;
            c = ctx->buffer.buf[ctx->pos];
            if (!(
                c == 'L' ||
                c == 'l'
            )) goto L0004;
            ctx->pos++;
        }
        {
            char c;
            if (pcc_refill_buffer(ctx, 1) < 1) goto L0004;
            c = ctx->buffer.buf[ctx->pos];
            if (!(
                c == 'S' ||
                c == 's'
            )) goto L0004;
            ctx->pos++;
        }
        {
            char c;
            if (pcc_refill_buffer(ctx, 1) < 1) goto L0004;
            c = ctx->buffer.buf[ctx->pos];
            if (!(
                c == 'E' ||
                c == 'e'
            )) goto L0004;
            ctx->pos++;
        }
        {
            pcc_thunk_t *const thunk = pcc_thunk__create_leaf(ctx->auxil, pcc_action_bool_2, 0, 0);
            thunk->data.leaf.capt0.range.start = chunk->pos;
            thunk->data.leaf.capt0.range.end = ctx->pos;
            pcc_thunk_array__add(ctx->auxil, &chunk->thunks, thunk);
        }
        goto L0001;
    L0004:;
        ctx->pos = p;
        pcc_thunk_array__revert(ctx->auxil, &chunk->thunks, n);
        {
            char c;
            if (pcc_refill_buffer(ctx, 1) < 1) goto L0005;
            c = ctx->buffer.buf[ctx->pos];
            if (!(
                c == 'T' ||
                c == 't'
            )) goto L0005;
            ctx->pos++;
        }
        {
            char c;
            if (pcc_refill_buffer(ctx, 1) < 1) goto L0005;
            c = ctx->buffer.buf[ctx->pos];
            if (!(
                c == 'R' ||
                c == 'r'
            )) goto L0005;
            ctx->pos++;
        }
        {
            char c;
            if (pcc_refill_buffer(ctx, 1) < 1) goto L0005;
            c = ctx->buffer.buf[ctx->pos];
            if (!(
                c == 'U' ||
                c == 'u'
            )) goto L0005;
            ctx->pos++;
        }
        {
            char c;
            if (pcc_refill_buffer(ctx, 1) < 1) goto L0005;
            c = ctx->buffer.buf[ctx->pos];
            if (!(
                c == 'E' ||
                c == 'e'
            )) goto L0005;
            ctx->pos++;
        }
        {
            pcc_thunk_t *const thunk = pcc_thunk__create_leaf(ctx->auxil, pcc_action_bool_3, 0, 0);
            thunk->data.leaf.capt0.range.start = chunk->pos;
            thunk->data.leaf.capt0.range.end = ctx->pos;
            pcc_thunk_array__add(ctx->auxil, &chunk->thunks, thunk);
        }
        goto L0001;
    L0005:;
        ctx->pos = p;
        pcc_thunk_array__revert(ctx->auxil, &chunk->thunks, n);
        goto L0000;
    L0001:;
    }
    return chunk;
L0000:;
    pcc_thunk_chunk__destroy(ctx->auxil, chunk);
    return NULL;
}

static pcc_thunk_chunk_t *pcc_evaluate_rule_space(mstro_stp_context_t *ctx) {
    pcc_thunk_chunk_t *const chunk = pcc_thunk_chunk__create(ctx->auxil);
    chunk->pos = ctx->pos;
    pcc_value_table__resize(ctx->auxil, &chunk->values, 0);
    pcc_capture_table__resize(ctx->auxil, &chunk->capts, 0);
    {
        char c;
        if (pcc_refill_buffer(ctx, 1) < 1) goto L0000;
        c = ctx->buffer.buf[ctx->pos];
        if (!(
            c == ' ' ||
            c == '\t' ||
            c == '\n' ||
            c == '\v' ||
            c == '\f' ||
            c == '\r'
        )) goto L0000;
        ctx->pos++;
    }
    {
        pcc_thunk_t *const thunk = pcc_thunk__create_leaf(ctx->auxil, pcc_action_space_0, 0, 0);
        thunk->data.leaf.capt0.range.start = chunk->pos;
        thunk->data.leaf.capt0.range.end = ctx->pos;
        pcc_thunk_array__add(ctx->auxil, &chunk->thunks, thunk);
    }
    return chunk;
L0000:;
    pcc_thunk_chunk__destroy(ctx->auxil, chunk);
    return NULL;
}

static pcc_thunk_chunk_t *pcc_evaluate_rule_number(mstro_stp_context_t *ctx) {
    pcc_thunk_chunk_t *const chunk = pcc_thunk_chunk__create(ctx->auxil);
    chunk->pos = ctx->pos;
    pcc_value_table__resize(ctx->auxil, &chunk->values, 1);
    pcc_capture_table__resize(ctx->auxil, &chunk->capts, 0);
    {
        const int p = ctx->pos;
        const int n = chunk->thunks.len;
        {
            int i;
            for (i = 0;; i++) {
                if (!pcc_apply_rule(ctx, pcc_evaluate_rule_space, &chunk->thunks, NULL)) goto L0003;
            }
        L0003:;
        }
        if (!pcc_apply_rule(ctx, pcc_evaluate_rule_signed_number, &chunk->thunks, &(chunk->values.buf[0]))) goto L0002;
        {
            pcc_thunk_t *const thunk = pcc_thunk__create_leaf(ctx->auxil, pcc_action_number_0, 1, 0);
            thunk->data.leaf.values.buf[0] = &(chunk->values.buf[0]);
            thunk->data.leaf.capt0.range.start = chunk->pos;
            thunk->data.leaf.capt0.range.end = ctx->pos;
            pcc_thunk_array__add(ctx->auxil, &chunk->thunks, thunk);
        }
        goto L0001;
    L0002:;
        ctx->pos = p;
        pcc_thunk_array__revert(ctx->auxil, &chunk->thunks, n);
        {
            int i;
            for (i = 0;; i++) {
                if (!pcc_apply_rule(ctx, pcc_evaluate_rule_space, &chunk->thunks, NULL)) goto L0005;
            }
        L0005:;
        }
        if (
            pcc_refill_buffer(ctx, 1) < 1 ||
            ctx->buffer.buf[ctx->pos] != '+'
        ) goto L0006;
        ctx->pos++;
    L0006:;
        {
            int i;
            for (i = 0;; i++) {
                if (!pcc_apply_rule(ctx, pcc_evaluate_rule_space, &chunk->thunks, NULL)) goto L0007;
            }
        L0007:;
        }
        if (!pcc_apply_rule(ctx, pcc_evaluate_rule_unsigned_number, &chunk->thunks, &(chunk->values.buf[0]))) goto L0004;
        {
            pcc_thunk_t *const thunk = pcc_thunk__create_leaf(ctx->auxil, pcc_action_number_1, 1, 0);
            thunk->data.leaf.values.buf[0] = &(chunk->values.buf[0]);
            thunk->data.leaf.capt0.range.start = chunk->pos;
            thunk->data.leaf.capt0.range.end = ctx->pos;
            pcc_thunk_array__add(ctx->auxil, &chunk->thunks, thunk);
        }
        goto L0001;
    L0004:;
        ctx->pos = p;
        pcc_thunk_array__revert(ctx->auxil, &chunk->thunks, n);
        goto L0000;
    L0001:;
    }
    return chunk;
L0000:;
    pcc_thunk_chunk__destroy(ctx->auxil, chunk);
    return NULL;
}

static pcc_thunk_chunk_t *pcc_evaluate_rule_signed_number(mstro_stp_context_t *ctx) {
    pcc_thunk_chunk_t *const chunk = pcc_thunk_chunk__create(ctx->auxil);
    chunk->pos = ctx->pos;
    pcc_value_table__resize(ctx->auxil, &chunk->values, 1);
    pcc_capture_table__resize(ctx->auxil, &chunk->capts, 0);
    {
        const int p = ctx->pos;
        const int n = chunk->thunks.len;
        if (
            pcc_refill_buffer(ctx, 1) < 1 ||
            ctx->buffer.buf[ctx->pos] != '-'
        ) goto L0002;
        ctx->pos++;
        {
            int i;
            for (i = 0;; i++) {
                if (!pcc_apply_rule(ctx, pcc_evaluate_rule_space, &chunk->thunks, NULL)) goto L0003;
            }
        L0003:;
        }
        if (!pcc_apply_rule(ctx, pcc_evaluate_rule_integer, &chunk->thunks, &(chunk->values.buf[0]))) goto L0002;
        {
            pcc_thunk_t *const thunk = pcc_thunk__create_leaf(ctx->auxil, pcc_action_signed_number_0, 1, 0);
            thunk->data.leaf.values.buf[0] = &(chunk->values.buf[0]);
            thunk->data.leaf.capt0.range.start = chunk->pos;
            thunk->data.leaf.capt0.range.end = ctx->pos;
            pcc_thunk_array__add(ctx->auxil, &chunk->thunks, thunk);
        }
        goto L0001;
    L0002:;
        ctx->pos = p;
        pcc_thunk_array__revert(ctx->auxil, &chunk->thunks, n);
        if (
            pcc_refill_buffer(ctx, 1) < 1 ||
            ctx->buffer.buf[ctx->pos] != '-'
        ) goto L0004;
        ctx->pos++;
        {
            int i;
            for (i = 0;; i++) {
                if (!pcc_apply_rule(ctx, pcc_evaluate_rule_space, &chunk->thunks, NULL)) goto L0005;
            }
        L0005:;
        }
        if (!pcc_apply_rule(ctx, pcc_evaluate_rule_decimal, &chunk->thunks, &(chunk->values.buf[0]))) goto L0004;
        {
            pcc_thunk_t *const thunk = pcc_thunk__create_leaf(ctx->auxil, pcc_action_signed_number_1, 1, 0);
            thunk->data.leaf.values.buf[0] = &(chunk->values.buf[0]);
            thunk->data.leaf.capt0.range.start = chunk->pos;
            thunk->data.leaf.capt0.range.end = ctx->pos;
            pcc_thunk_array__add(ctx->auxil, &chunk->thunks, thunk);
        }
        goto L0001;
    L0004:;
        ctx->pos = p;
        pcc_thunk_array__revert(ctx->auxil, &chunk->thunks, n);
        goto L0000;
    L0001:;
    }
    return chunk;
L0000:;
    pcc_thunk_chunk__destroy(ctx->auxil, chunk);
    return NULL;
}

static pcc_thunk_chunk_t *pcc_evaluate_rule_unsigned_number(mstro_stp_context_t *ctx) {
    pcc_thunk_chunk_t *const chunk = pcc_thunk_chunk__create(ctx->auxil);
    chunk->pos = ctx->pos;
    pcc_value_table__resize(ctx->auxil, &chunk->values, 1);
    pcc_capture_table__resize(ctx->auxil, &chunk->capts, 0);
    {
        const int p = ctx->pos;
        const int n = chunk->thunks.len;
        if (!pcc_apply_rule(ctx, pcc_evaluate_rule_integer, &chunk->thunks, &(chunk->values.buf[0]))) goto L0002;
        {
            pcc_thunk_t *const thunk = pcc_thunk__create_leaf(ctx->auxil, pcc_action_unsigned_number_0, 1, 0);
            thunk->data.leaf.values.buf[0] = &(chunk->values.buf[0]);
            thunk->data.leaf.capt0.range.start = chunk->pos;
            thunk->data.leaf.capt0.range.end = ctx->pos;
            pcc_thunk_array__add(ctx->auxil, &chunk->thunks, thunk);
        }
        goto L0001;
    L0002:;
        ctx->pos = p;
        pcc_thunk_array__revert(ctx->auxil, &chunk->thunks, n);
        if (!pcc_apply_rule(ctx, pcc_evaluate_rule_decimal, &chunk->thunks, &(chunk->values.buf[0]))) goto L0003;
        {
            pcc_thunk_t *const thunk = pcc_thunk__create_leaf(ctx->auxil, pcc_action_unsigned_number_1, 1, 0);
            thunk->data.leaf.values.buf[0] = &(chunk->values.buf[0]);
            thunk->data.leaf.capt0.range.start = chunk->pos;
            thunk->data.leaf.capt0.range.end = ctx->pos;
            pcc_thunk_array__add(ctx->auxil, &chunk->thunks, thunk);
        }
        goto L0001;
    L0003:;
        ctx->pos = p;
        pcc_thunk_array__revert(ctx->auxil, &chunk->thunks, n);
        goto L0000;
    L0001:;
    }
    return chunk;
L0000:;
    pcc_thunk_chunk__destroy(ctx->auxil, chunk);
    return NULL;
}

static pcc_thunk_chunk_t *pcc_evaluate_rule_integer(mstro_stp_context_t *ctx) {
    pcc_thunk_chunk_t *const chunk = pcc_thunk_chunk__create(ctx->auxil);
    chunk->pos = ctx->pos;
    pcc_value_table__resize(ctx->auxil, &chunk->values, 0);
    pcc_capture_table__resize(ctx->auxil, &chunk->capts, 1);
    {
        const int p = ctx->pos;
        int q;
        {
            const int p = ctx->pos;
            int i;
            for (i = 0;; i++) {
                char c;
                if (pcc_refill_buffer(ctx, 1) < 1) goto L0001;
                c = ctx->buffer.buf[ctx->pos];
                if (!(c >= '0' && c <= '9')) goto L0001;
                ctx->pos++;
            }
        L0001:;
            if (i < 1) {
                ctx->pos = p;
                goto L0000;
            }
        }
        q = ctx->pos;
        chunk->capts.buf[0].range.start = p;
        chunk->capts.buf[0].range.end = q;
    }
    {
        pcc_thunk_t *const thunk = pcc_thunk__create_leaf(ctx->auxil, pcc_action_integer_0, 0, 1);
        thunk->data.leaf.capts.buf[0] = &(chunk->capts.buf[0]);
        thunk->data.leaf.capt0.range.start = chunk->pos;
        thunk->data.leaf.capt0.range.end = ctx->pos;
        pcc_thunk_array__add(ctx->auxil, &chunk->thunks, thunk);
    }
    return chunk;
L0000:;
    pcc_thunk_chunk__destroy(ctx->auxil, chunk);
    return NULL;
}

static pcc_thunk_chunk_t *pcc_evaluate_rule_decimal(mstro_stp_context_t *ctx) {
    pcc_thunk_chunk_t *const chunk = pcc_thunk_chunk__create(ctx->auxil);
    chunk->pos = ctx->pos;
    pcc_value_table__resize(ctx->auxil, &chunk->values, 0);
    pcc_capture_table__resize(ctx->auxil, &chunk->capts, 1);
    {
        const int p = ctx->pos;
        int q;
        {
            const int p = ctx->pos;
            int i;
            for (i = 0;; i++) {
                char c;
                if (pcc_refill_buffer(ctx, 1) < 1) goto L0001;
                c = ctx->buffer.buf[ctx->pos];
                if (!(c >= '0' && c <= '9')) goto L0001;
                ctx->pos++;
            }
        L0001:;
            if (i < 1) {
                ctx->pos = p;
                goto L0000;
            }
        }
        if (
            pcc_refill_buffer(ctx, 1) < 1 ||
            ctx->buffer.buf[ctx->pos] != '.'
        ) goto L0000;
        ctx->pos++;
        {
            int i;
            for (i = 0;; i++) {
                char c;
                if (pcc_refill_buffer(ctx, 1) < 1) goto L0002;
                c = ctx->buffer.buf[ctx->pos];
                if (!(c >= '0' && c <= '9')) goto L0002;
                ctx->pos++;
            }
        L0002:;
        }
        q = ctx->pos;
        chunk->capts.buf[0].range.start = p;
        chunk->capts.buf[0].range.end = q;
    }
    {
        pcc_thunk_t *const thunk = pcc_thunk__create_leaf(ctx->auxil, pcc_action_decimal_0, 0, 1);
        thunk->data.leaf.capts.buf[0] = &(chunk->capts.buf[0]);
        thunk->data.leaf.capt0.range.start = chunk->pos;
        thunk->data.leaf.capt0.range.end = ctx->pos;
        pcc_thunk_array__add(ctx->auxil, &chunk->thunks, thunk);
    }
    return chunk;
L0000:;
    pcc_thunk_chunk__destroy(ctx->auxil, chunk);
    return NULL;
}

static pcc_thunk_chunk_t *pcc_evaluate_rule_EOF(mstro_stp_context_t *ctx) {
    pcc_thunk_chunk_t *const chunk = pcc_thunk_chunk__create(ctx->auxil);
    chunk->pos = ctx->pos;
    pcc_value_table__resize(ctx->auxil, &chunk->values, 0);
    pcc_capture_table__resize(ctx->auxil, &chunk->capts, 0);
    {
        const int p = ctx->pos;
        if (pcc_refill_buffer(ctx, 1) < 1) goto L0001;
        ctx->pos++;
        ctx->pos = p;
        goto L0000;
    L0001:;
        ctx->pos = p;
    }
    return chunk;
L0000:;
    pcc_thunk_chunk__destroy(ctx->auxil, chunk);
    return NULL;
}

mstro_stp_context_t *mstro_stp_create(struct mstro_stp_parser_ctx *auxil) {
    return pcc_context__create(auxil);
}

int mstro_stp_parse(mstro_stp_context_t *ctx, struct mstro_stp_val **ret) {
    pcc_thunk_array_t thunks;
    pcc_thunk_array__init(ctx->auxil, &thunks, PCC_ARRAYSIZE);
    if (pcc_apply_rule(ctx, pcc_evaluate_rule_type_expression, &thunks, ret))
        pcc_do_action(ctx, &thunks, ret);
    else
        PCC_ERROR(ctx->auxil);
    pcc_commit_buffer(ctx);
    pcc_thunk_array__term(ctx->auxil, &thunks);
    return pcc_refill_buffer(ctx, 1) >= 1;
}

void mstro_stp_destroy(mstro_stp_context_t *ctx) {
    pcc_context__destroy(ctx);
}

#include "maestro/logging.h"

#define MIN(x,y) ((x)<(y) ? (x) : (y))

#line 576 "schema_type_parse.peg"
mstro_status
mstro_schema_type_parse(const char *string, struct mstro_stp_val **res)
{
  struct mstro_stp_parser_ctx in = { string, 0, false };
  mstro_stp_context_t *ctx = mstro_stp_create(&in);
  if(ctx==NULL)
    return MSTRO_NOMEM;
  int i = mstro_stp_parse(ctx, res);
  DEBUG("parser result code: %d\n", i);
  if(in.got_error) {
    *res = NULL;
    /* FIXME: we need to figure out if we leak partial parse results here */
    return MSTRO_FAIL;
  }
  mstro_stp_destroy(ctx);
  return MSTRO_OK;
}

mstro_status
mstro_stp_val_dispose(struct mstro_stp_val *v)
{
  if(v==NULL) {
    ERR("NULL stp_val argument\n");
    return MSTRO_INVARG;
  }
  switch(v->kind) {
    case MSTRO_STP_ERROR:
      if(v->errmsg)
        free(v->errmsg);
      break;
    case MSTRO_STP_STR:
      if(v->str_excludedchars!=NULL)
        free(v->str_excludedchars);
      break;
    case MSTRO_STP_REGEX:
      if(v->regex_name!=NULL)
        free(v->regex_name);
      for(size_t i=0; i<v->regex_numpatterns; i++) 
        free(v->regex_patterns[i]);
      if(v->regex_patterns!=NULL)
        free(v->regex_patterns);
      break;
    case MSTRO_STP_LIST:
      if(v->list_entry) {
          mstro_stp_val_dispose(v->list_entry);
      }
      if(v->list_tail) {
          mstro_stp_val_dispose(v->list_tail);
      }
      break;
    case MSTRO_STP_NAME:
      if(v->nameval) 
              free(v->nameval);
      break;
    default:
      break;
  }
  free(v);
  return MSTRO_OK;
}

void
mstro_stp_val__describe(const struct mstro_stp_val *v)
{
  DEBUG("v %p\n", v);
  if(v!=NULL) {
    DEBUG("v kind %d\n", v->kind);
    switch(v->kind) {
    case MSTRO_STP_ERROR:
      DEBUG("v kind: ERROR:    %s\n", v->errmsg); break;
    case MSTRO_STP_INTVAL:
      DEBUG("v kind: INTVAL    %" PRIi64 "\n", v->intval); break;
    case MSTRO_STP_UINTVAL:
      DEBUG("v kind: UINTVAL   %" PRIu64 "\n", v->uintval); break;
    case MSTRO_STP_FLOATVAL:
      DEBUG("v kind: FLOATVAL  %f\n", v->floatval); break;
    case MSTRO_STP_DOUBLEVAL:
      DEBUG("v kind: DOUBLEVAL %g\n", v->doubleval); break;
    case MSTRO_STP_STRVAL:
      DEBUG("v kind: STRVAL    %s\n", v->strval); break;

    case MSTRO_STP_BOOL:
      DEBUG("v kind: BOOL\n"); break;
    case MSTRO_STP_UINT:
      DEBUG("v kind: UINT   (min=%" PRIu64 ", max=%" PRIu64 ")\n", v->uint_min, v->uint_max); break;
    case MSTRO_STP_INT:
      DEBUG("v kind: INT    (min=%" PRIi64 ", max=%" PRIi64 ")\n", v->int_min, v->int_max); break;
    case MSTRO_STP_FLOAT:
      DEBUG("v kind: FLOAT  (min=%f, max=%f)\n", v->float_min, v->float_max); break;
    case MSTRO_STP_DOUBLE:
      DEBUG("v kind: DOUBLE (min=%g, max=%g)\n", v->double_min, v->double_max); break;
    case MSTRO_STP_STR:
      DEBUG("v kind: STRING (min=%zu, max=%zu, excluded='%s')\n",
      	    v->str_minlen, v->str_maxlen, v->str_excludedchars == NULL ? "" : v->str_excludedchars ); 
      break;
    case MSTRO_STP_REGEX:
      DEBUG("v kind: REGEX (%d substrings, ignore_case=%d, name='%s')\n",
            v->regex_numpatterns, v->regex_ignorecase, v->regex_name ==NULL ? "" : v->regex_name);
      break;
    case MSTRO_STP_BLOB:
      DEBUG("v kind: BLOB (min=%" PRIu64 ", max=%" PRIu64 ")\n", v->blob_minlen, v->blob_maxlen);
      break;
    case MSTRO_STP_TIMESTAMP:
      DEBUG("v kind: TIMESTAMP\n");
      break;
    case MSTRO_STP_POINTER:
      DEBUG("v kind: POINTER\n"); break;

    case MSTRO_STP_BOOLVAL:
    case MSTRO_STP_MININT:
    case MSTRO_STP_MAXINT:
    case MSTRO_STP_MINUINT:
    case MSTRO_STP_MAXUINT:
    case MSTRO_STP_EXCLSTR:
    case MSTRO_STP_ICASE:
    case MSTRO_STP_NAME:
      DEBUG("v kind %d, describe unimplemented\n", v->kind);
      break;

    default:
      ERR("Unexpected kind: %d\n", v->kind);
    }
  }
}


/** build a user-understandable type value from TYPENAME and 
 ** the applicable arguments */

struct mstro_stp_val *
mstro_stp_val__build_restricted_type(
  struct mstro_stp_val *typename,
  struct mstro_stp_val *args)
{
  assert(typename!=NULL);
  struct mstro_stp_val *result, *leftovers = NULL;

  result = typename;

  switch(typename->kind) {
    case MSTRO_STP_ERROR:
      leftovers = args;
      break;
    case MSTRO_STP_BOOL:
      if(args!=NULL) {
        ERR("boolean type does not accept type restrictions, ignoring them\n");
        leftovers = args;
      };
      break;
    case MSTRO_STP_POINTER:
      if(args!=NULL) {
        ERR("pointer type does not accept type restrictions, ignoring them\n");
        leftovers = args;
      };
      break;
 
   /* pick out the ones we understand, accumulate the rest in leftovers */
    case MSTRO_STP_UINT: {
      while(args!=NULL) {
       assert(args->kind==MSTRO_STP_LIST);
       struct mstro_stp_val *tmp = args;
       args = args->list_tail;
       tmp->list_tail = NULL;

       switch(tmp->list_entry->kind) {
         case MSTRO_STP_MINUINT: 
           result->uint_min = tmp->list_entry->minuintval; break;
         case MSTRO_STP_MAXUINT: 
           result->uint_max = tmp->list_entry->maxuintval; break;
         default:
           ERR("Illegal type restriction for unsigned integer: %d\n", tmp->list_entry->kind);
       }
       
       mstro_stp_val_dispose(tmp);
      };
      break;
      }
      
    case MSTRO_STP_INT: {
      while(args!=NULL) {
       assert(args->kind==MSTRO_STP_LIST);
       struct mstro_stp_val *tmp = args;
       args = args->list_tail;
       tmp->list_tail = NULL;
       
       switch(tmp->list_entry->kind) {
         case MSTRO_STP_MININT: 
           result->int_min = tmp->list_entry->minintval;
	   break;
         case MSTRO_STP_MINUINT: 
           if(tmp->list_entry->minuintval>(uint64_t)INT64_MAX) {
             ERR("signed int min %" PRIu64 "exceeds INT64_MAX\n", tmp->list_entry->minuintval);
           }
           result->int_min = (tmp->list_entry->minuintval < INT64_MAX)
	   		     ? (int64_t)tmp->list_entry->minuintval : INT64_MAX;
           break;
         case MSTRO_STP_MAXINT: 
           result->int_max = tmp->list_entry->maxintval;
	   break;
         case MSTRO_STP_MAXUINT: 
           DEBUG("int, encountered maxuint arg of %" PRIu64 "\n", tmp->list_entry->maxuintval);
           if(tmp->list_entry->maxuintval>(uint64_t)INT64_MAX) {
             ERR("signed int max %" PRIu64 "exceeds INT64_MAX\n", tmp->list_entry->maxuintval);
           }
           result->int_max = (tmp->list_entry->maxuintval < INT64_MAX) 
                             ? (int64_t)tmp->list_entry->maxuintval : INT64_MAX ;
           break;
         default:
           ERR("Illegal type restriction for signed integer: %d\n", tmp->list_entry->kind);
       }
       
       mstro_stp_val_dispose(tmp);
      };
      break;
      }

    case MSTRO_STP_FLOAT: {
      while(args!=NULL) {
       assert(args->kind==MSTRO_STP_LIST);
       struct mstro_stp_val *tmp = args;
       args = args->list_tail;
       tmp->list_tail = NULL;

       switch(tmp->list_entry->kind) {
         case MSTRO_STP_MINFLOAT: 
           result->float_min = tmp->list_entry->minfloatval; break;
         case MSTRO_STP_MAXFLOAT: 
           result->float_max = tmp->list_entry->maxfloatval; break;
         default:
           ERR("Illegal type restriction for float: %d\n", tmp->list_entry->kind);
       }
       
       mstro_stp_val_dispose(tmp);
      };
      break;
      }

    case MSTRO_STP_DOUBLE: {
      while(args!=NULL) {
       assert(args->kind==MSTRO_STP_LIST);
       struct mstro_stp_val *tmp = args;
       args = args->list_tail;
       tmp->list_tail = NULL;

       switch(tmp->list_entry->kind) {
         case MSTRO_STP_MINDOUBLE: 
           result->double_min = tmp->list_entry->mindoubleval; break;
         case MSTRO_STP_MAXDOUBLE: 
           result->double_max = tmp->list_entry->maxdoubleval; break;
         default:
           ERR("Illegal type restriction for double: %d\n", tmp->list_entry->kind);
       }
       
       mstro_stp_val_dispose(tmp);
      };
      break;
      }
    case MSTRO_STP_STR: {
      while(args!=NULL) {
       assert(args->kind==MSTRO_STP_LIST);
       struct mstro_stp_val *tmp = args;
       args = args->list_tail;
       tmp->list_tail = NULL;
       
       switch(tmp->list_entry->kind) {
         case MSTRO_STP_EXCLSTR: 
           result->str_excludedchars = tmp->list_entry->exclstrval;
           tmp->list_entry->exclstrval = NULL; // passed on to result
           break;
         case MSTRO_STP_MAXINT:
           result->str_maxlen = tmp->list_entry->maxintval;
           break;
         case MSTRO_STP_MAXUINT:
           result->str_maxlen = tmp->list_entry->maxuintval; 
           break;
         case MSTRO_STP_MININT:
           result->str_minlen = tmp->list_entry->minintval; 
           break;
         case MSTRO_STP_MINUINT:
           result->str_minlen = tmp->list_entry->minuintval; 
           break;
         default:
           ERR("Illegal type restriction for string: %d\n", tmp->list_entry->kind);
       }
       /* clamp to protobuf permitted max */
       if(tmp->list_entry->kind==MSTRO_STP_MININT||tmp->list_entry->kind==MSTRO_STP_MINUINT) {
         if(result->str_minlen > MSTRO_STP_VAL_SIZE_MAX) {
           ERR("string min %zu larger than supported maximum, clamping\n", 
               result->str_minlen);
           result->str_minlen = MSTRO_STP_VAL_SIZE_MAX;
         }
       }
       if(tmp->list_entry->kind==MSTRO_STP_MAXINT||tmp->list_entry->kind==MSTRO_STP_MAXUINT) {
         if(result->str_maxlen > MSTRO_STP_VAL_SIZE_MAX) {
           ERR("string max %zu larger than supported maximum, clamping\n", 
               result->str_maxlen);
           result->str_maxlen = MSTRO_STP_VAL_SIZE_MAX;
         }
       }
       
       mstro_stp_val_dispose(tmp);
      };
      break;
      }
    case MSTRO_STP_BLOB: {
      while(args!=NULL) {
       assert(args->kind==MSTRO_STP_LIST);
       struct mstro_stp_val *tmp = args;
       args = args->list_tail;
       tmp->list_tail = NULL;
       
       switch(tmp->list_entry->kind) {
         case MSTRO_STP_MAXINT:
           result->blob_maxlen = tmp->list_entry->maxintval;
           break;
         case MSTRO_STP_MAXUINT:
           result->blob_maxlen = tmp->list_entry->maxuintval; 
           break;
         case MSTRO_STP_MININT:
           result->blob_minlen = tmp->list_entry->minintval; 
           break;
         case MSTRO_STP_MINUINT:
           result->blob_minlen = tmp->list_entry->minuintval; 
           break;
         default:
           ERR("Illegal type restriction for blob: %d\n", tmp->list_entry->kind);
       }
       /* clamp to protobuf permitted max */
       if(tmp->list_entry->kind==MSTRO_STP_MININT||tmp->list_entry->kind==MSTRO_STP_MINUINT) {
         if(result->blob_minlen > MSTRO_STP_VAL_SIZE_MAX) {
           ERR("blob min %zu larger than supported maximum, clamping\n", 
               result->blob_minlen);
           result->blob_minlen = MSTRO_STP_VAL_SIZE_MAX;
         }
       }
       if(tmp->list_entry->kind==MSTRO_STP_MAXINT||tmp->list_entry->kind==MSTRO_STP_MAXUINT) {
         if(result->blob_maxlen > MSTRO_STP_VAL_SIZE_MAX) {
           ERR("blob max %zu larger than supported maximum, clamping\n", 
               result->blob_maxlen);
           result->blob_maxlen = MSTRO_STP_VAL_SIZE_MAX;
         }
       }
       mstro_stp_val_dispose(tmp);
      };
      break;
      }

    case MSTRO_STP_REGEX: {
      struct mstro_stp_val *patterns = NULL;
      result->regex_numpatterns=0;

      while(args!=NULL) {
       assert(args->kind==MSTRO_STP_LIST);
       struct mstro_stp_val *tmp = args;
       args = args->list_tail;
       tmp->list_tail = NULL;
       
       DEBUG("looking at %d\n", tmp->list_entry->kind);
       switch(tmp->list_entry->kind) {
         case MSTRO_STP_ICASE:
           result->regex_ignorecase = tmp->list_entry->icase;
           break;
         case MSTRO_STP_NAME:
           result->regex_name = tmp->list_entry->nameval;
           tmp->list_entry->nameval = NULL; // moved to result
           DEBUG("regex name '%s'\n", result->regex_name);
           break;
         case MSTRO_STP_STRVAL: 
           /* patterns; push to pattern stack and count */
           LL_PREPEND2(patterns,tmp,list_tail);
           result->regex_numpatterns++;
           tmp=NULL; /* moved to patterns stack */
           DEBUG("Found pattern |%s|, have %zu\n", 
                 patterns->list_entry->strval, 
                 result->regex_numpatterns);
           break;
         default:
           ERR("Illegal type arg or restriction for regex: %d\n", tmp->list_entry->kind);
       }
       if(tmp!=NULL)
         mstro_stp_val_dispose(tmp);
      };
      if(result->regex_numpatterns==0) {
        ERR("Regex without any pattern, defaulting to \"\"\n");
        result->regex_numpatterns=1;
        result->regex_patterns = malloc(sizeof(char*));
        if(result->regex_patterns == NULL) {
          ERR("Failed to allocate for regex patterns\n");
          abort();
        }
        result->regex_patterns[0] = strdup("");
        if(result->regex_patterns[0] == NULL) {
          ERR("Failed to allocate for regex\n");
          abort();
        }
      } else {
        result->regex_patterns = malloc(sizeof(char*)*result->regex_numpatterns);
        if(result->regex_patterns == NULL) {
          ERR("Failed to allocate for regex patterns\n");
          abort();
        }
        /* insert, reversing */
       struct mstro_stp_val *tmp = patterns;
       size_t i;
        for(i=result->regex_numpatterns, tmp = patterns;
            i-->0;
            tmp = tmp->list_tail) {
          result->regex_patterns[i] = tmp->list_entry->strval;
	  tmp->list_entry->strval = NULL; /* moved to result */
        }
        mstro_stp_val_dispose(patterns);
      }


      break;
      }
    case MSTRO_STP_TIMESTAMP: {
      leftovers = args; /* no args supported */
      break;
    }
    default:
      ERR("type parse intermediate kind %d should not be returned\n",
          typename->kind);
      mstro_stp_val_dispose(result);
      result=mstro_stp_val_alloc(MSTRO_STP_ERROR);
      result->errmsg = strdup("Parser defective");
      leftovers = args;
      break;
  }
  if(leftovers!=NULL) 
    mstro_stp_val_dispose(leftovers);

  return result;
}

