/*
 * Copyright (C) 2020      Cray UK
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are
 * met:
 *
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * 3. Neither the name of the copyright holder nor the names of its
 *    contributors may be used to endorse or promote products derived from
 *    this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
 * IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
 * TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A
 * PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
 * HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
 * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

#ifndef MMB_PROVIDER_OPENCL_H
#define MMB_PROVIDER_OPENCL_H

#include "mmb_error.h"
#include "mmb_memory.h"

#ifdef __cplusplus
extern "C" {
#endif

#if HAVE_OPENCL
typedef cl_device_id mmb_cl_device_id;
typedef cl_context mmb_cl_context;
typedef cl_command_queue mmb_cl_command_queue;
#else
typedef int mmb_cl_device_id;
typedef int mmb_cl_context;
typedef int mmb_cl_command_queue;
#endif /* HAVE_OPENCL */

typedef struct mmb_opencl_t {
  mmb_cl_device_id     device;
  mmb_cl_context       context;
  mmb_cl_command_queue queue;
}mmb_opencl_t;


// mmbError mmb_meminterface_config_create_opencl(mmb_opencl_t** iprms, 
//                                                cl_context ctx, 
//                                                cl_command_queue q);

#ifdef __cplusplus
}
#endif

#endif
