/* -*- mode:c -*- */
/** @file
 ** @brief Maestro Pool Manager interface 
 **/
/*
 * Copyright (C) 2019 Cray Computer GmbH
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are
 * met:
 *
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * 3. Neither the name of the copyright holder nor the names of its
 *    contributors may be used to endorse or promote products derived from
 *    this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
 * IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
 * TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A
 * PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
 * HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
 * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

#ifndef MAESTRO_I_POOL_MANAGER_H_
#define MAESTRO_I_POOL_MANAGER_H_ 1

/* #include "maestro/i_pool_manager_protocol.h" */
#include "maestro/status.h"

/** endpoint abstraction */
struct mstro_endpoint;

/* /\** All of these functions are useable only after the @ref */
/*  * mstro_pm_attach has been performed *\/ */

/* /\** Send a message (not expecting a reply) *\/ */
/* mstro_status */
/* mstro_pm_send(struct mstro_msg *msg); */

/* /\** Send a message (blocking for reply). *\/ */
/* mstro_status */
/* mstro_pm_sendrecv(struct mstro_msg *msg, struct mstro_msg *reply); */

/* /\** handle for async messages *\/ */
/* typedef struct mstro_msg_handle_ *mstro_msg_handle; */

/* /\** Send message async, not expecting a reply *\/ */
/* mstro_status */
/* mstro_pm_send_async(struct mstro_msg *msg, mstro_msg_handle *handle); */

/* /\** Send a message async, reply can be extracted from handle. *\/ */
/* mstro_status */
/* mstro_pm_sendrecv_async(struct mstro_msg *msg, mstro_msg_handle *handle); */

/* /\** block until communication associated with handle has completed *\/ */
/* mstro_status */
/* mstro_msg_wait(mstro_msg_handle handle); */

/* /\** check if communication associated with handle has completed *\/ */
/* mstro_status */
/* mstro_msg_test(mstro_msg_handle handle, bool done); */

/* /\** retrieve reply message of communication associated with handle *\/ */
/* mstro_status */
/* mstro_msg_handle_reply(mstro_msg_handle handle, struct mstro_msg *reply); */




#endif /* MAESTRO_I_POOL_MANAGER_H_ */
